﻿------------------------------------------
--              Master Cook             --
--               by Khrill              --
--                                      --
--                v 1.4.0               --
------------------------------------------

local KMC = {}
KMC.name  = "KhrillMasterCook"
KMC.titleName = "Master Cook"
KMC.version = "1.4.0"

local COLOR_KHRILLSELECT = "FF6A00" -- orange ^^
local COLOR_DISABLED = "303030" -- gray black
local COLOR_NOCOLOR = "FFFFFF" --transparent
local COLOR_TITLE = "FF0000" -- red
local COLOR_ICON = "FFFFFF" --white
local COLOR_TEXT = "C5C29E" --"FFFACD" --white
local COLOR_LOCK = "FF0000"
local COLOR_QUALITY = {
	[0] = "0A0A0A",
	[1] = "FFFACD", -- white
	[2] = "2DC50E", --"267F00", -- green
	[3] = "3A92FF", --"2655FF", -- blue
	[4] = "A02EF7", --"8244FF", -- purple
	[5] = "FFD800", -- gold
}

local FILTER_CATEGORY = "1"
local FILTER_EFFECT = "2"
local FILTER_LEVEL = "3"
local FILTER_SEARCH = "4"
local FILTER_SORT = "5"

KMC.BGTexturesLabel = {"No texture", "Paper book", "Skin book", "Rubbing book", "Note", "Letter", "Stone tablet"}
KMC.BGTextures = {
	[1] = "/esoui/art/buttons/swatchframe_down.dds", 
	[2] = "/esoui/art/lorelibrary/lorelibrary_paperbook.dds",
	[3] = "/esoui/art/lorelibrary/lorelibrary_skinbook.dds",
	[4] = "/esoui/art/lorelibrary/lorelibrary_rubbingbook.dds",
	[5] = "/esoui/art/lorelibrary/lorelibrary_note.dds",
	[7] = "/esoui/art/lorelibrary/lorelibrary_letter.dds",
	[8] = "/esoui/art/lorelibrary/lorelibrary_stonetablet.dds",
}
KMC.BGTexturesCoord = { -- left, right, top, bottom
	[2] = {.03,.96,.14,.85},
	[3] = {.03,.97,.14,.84},
	[4] = {.03,.98,.14,.86},
	[5] = {.19,.80,.07,.91},
	[6] = {.19,.80,.07,.91},
	[7] = {.05,.95,.06,.96},
}

KMC.defaults = {
	Enable	= true,
	anchor	= {TOP, TOP, -200, 120},
	BG		= 3,
	BGColor	= "FFFFA0",
	enableButton = true,
	charButton = true,
	statLvl = false,
	XPMode = true,
	sysmessage = false,
	msgWindow = true,
	EsoUiFade = true,
	saveFilter = false,
	saveFilterValue = nil,
	ingredientEnable = true,
	ingredientQuantity = false,
	itemLevel = false,
	ItemSaver = true,
	ItemSaverLock = false,
	FCOItemSaver = true,
	FCOItemSaverLock = false,
}
KMC.accountDefaults = {
	ItemSaved = {},
}
KMC.settings = KMC.defaults
KMC.accountSettings = KMC.accountDefaults

KMC.savedVars = nil
KMC.activeAddon = {
	AdvancedFilters = false,
	WeaponChargeAlert = false,
	KhrillCraftingPostit = false,
	ItemSaver = false,
	FCOItemSaver = false,
	FireFilters = false,
}
KMC.itemSaverFilter = false
KMC.FCOitemSaverFilter = false
KMC.isDebug = false
KMC.langString = nil

KMC.activeChar = nil
KMC.selectedChar = nil
KMC.characterList = {}
KMC.maxRow = 16 -- max of recipes list (slider)
KMC.maxRecipes = 0
KMC.selectedRecipe = nil
KMC.writRecipes = nil
KMC.MsgWindow = nil
KMC.sliderOffset = 0
KMC.Tooltip = nil
KMC.onStation = false
KMC.KCPHidden = nil

KMC.RecipeList = nil
--[[	KMC.RecipeList[recipeListIndex] = {
	--		name=recipeListName,
	--		icon=upIcon,
	--		count=total recipes number in category,
	--		known=recipes number known in category,
	--		recipes = {
	--			[recipeIndex] = {
	--				known = true/false,
	--				enable = has suffisant provisionning rank,
	--				lock = lock by addon (itemSaver or FCOitemSaver),
	--				ingredientType = special ingredient Type
	--				listIndex = recipeListIndex
	--				index = recipeIndex
	--				name = RecipeName,
	--				icon = RecipeIcon,
	--				level = RecipeLevel,
	--				quality = RecipeQuality,
	--				itemId = result item ID
	--				itemLink = result item link
	--				itemEffect = result item bonus
	--				itemLevel = result item lvl
	--				itemLocked = result item locked by addon (itemSaver or FCOitemSaver),
	--  	    	count = nbCraftedRecipe,
	--				ingredients = {
	--					[ingredientIndex] = {id=itemId, name=conditionText, icon=icon, quality=quality, quantity=requiredQuantity}
	--				}
	--			}
	--		}
	--	}
]]
KMC.RecipesESOTree = {}
KMC.RecipeQuality = { -- quality for recipe type
	[4] = 3,
	[5] = 3,
	[6] = 3,
	[7] = 4,
	[11] = 3,
	[12] = 3,
	[13] = 3,
	[14] = 4,	
	[15] = 5,
	[16] = 5,
}
KMC.RecipeEffect = { -- +1=Max Health, +2=Max Magicka, +4=Max Stamina, +8=Regen Health, +16=Regen Magicka, +32=Regen Stamina
	[1] = "1", --1,
	[2] = "2", --2,
	[3] = "3", --4,
	[4] = "12", --3,
	[5] = "13", --5,
	[6] = "23", --6,
	[7] = "123", --7,
	[8] = "4", --8,
	[9] = "5", --16,
	[10] = "6", --32,
	[11] = "45", --24,
	[12] = "46", --40,
	[13] = "56", --48,
	[14] = "456", --56,	
}
KMC.RecipeLevel = { -- level for filter
	[1] = 1,
	[2] = 20,
	[3] = 30,
	[4] = 40,
	[5] = 60,
	[6] = 100,
	[7] = 150,
	[8] = 999,
}
KMC.RecipeLevelLabel = { -- label level for result item
	[1] = "1-15",
	[2] = "20-25",
	[3] = "30-35",
	[4] = "40-45",
	[5] = "60",
	[6] = "100",
	[7] = "150+",
}
KMC.RecipeCount = {
	[1] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[2] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[3] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[4] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[5] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[6] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[7] = {[1]=5,[2]=5,[3]=5,[4]=5,[5]=5,[6]=6}, --purple
	[8] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[9] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[10] = {[1]=12,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6},
	[11] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[12] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[13] = {[1]=6,[2]=6,[3]=6,[4]=6,[5]=6,[6]=6}, --blue
	[14] = {[1]=5,[2]=5,[3]=5,[4]=5,[5]=5,[6]=6}, --purple
}

KMC.GlobalRecipes = {}
--[[	KMC.GlobalRecipes[<character>] = {
	--		classId = ,
	--		Recipes = KMC.RecipeList
	--	}
]]
KMC.Ingredient = nil
--[[	KMC.Ingredient[itemId] = {
	--		name = ingredient name,
	--		icon = icon,
	--		quality = quality,
	--		count= total in bag&bank,
	--		lock = lock by addon (itemSaver or FCOitemSaver)
	--	}
]]


local CraftTable = {
	[CRAFTING_TYPE_PROVISIONING] = "Provisioning",
}

local TEXTURE_ICON = {
	["Left"] = "/esoui/art/icons/ability_provisioner_002.dds",
	["Right"] = "/esoui/art/icons/ability_provisioner_006.dds",
	["Minus"] = "/esoui/art/buttons/minus_up.dds",
	["Plus"] = "/esoui/art/buttons/plus_up.dds",
	["Outline"] = KMC.name .. "/art/gridItem_outline.dds",
	["Slider"] = "/esoui/art/miscellaneous/scrollbox_elevator.dds",
	["Close"] = "/esoui/art/buttons/cancel_up.dds",
	["Effect1"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorehealth_match.dds",
	["Effect2"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restoremagicka_match.dds",
	["Effect3"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorestamina_match.dds",
	["Effect4"] = "/esoui/art/icons/progression_tabicon_healinglight_down.dds",
	["Effect5"] = "/esoui/art/icons/progression_tabicon_sunmagic_down.dds",
	["Effect6"] = "/esoui/art/icons/progression_tabicon_magma_down.dds",
	["KCP"] = "/esoui/art/lorelibrary/lorelibrary_scroll.dds",
	["Lock"] = "/esoui/art/miscellaneous/locked_down.dds", --/esoui/art/progression/lock.dds
}
local TEXTURE_CLASS = {
	[0] = "/esoui/art/miscellaneous/help_icon.dds",
	[1] = "/esoui/art/contacts/social_classicon_dragonknight.dds",
	[2] = "/esoui/art/contacts/social_classicon_sorcerer.dds",
	[3] = "/esoui/art/contacts/social_classicon_nightblade.dds",
	[6] = "/esoui/art/contacts/social_classicon_templar.dds",
}

local SOUND_UNKNOW = SOUNDS.ABILITY_SLOT_CLEARED

-- // **********
-- //  Utility
-- // **********
local function HexToRGBA( hex )
	if string.len(hex) == 6 then hex = hex.."FF" end
    local rhex, ghex, bhex, ahex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6), string.sub(hex, 7, 8)
    return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255, tonumber(ahex, 16)/255
end
local function RGBAToHex( r, g, b, a )
	if a == nil then a = 1 end
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.upper(string.format("%02x%02x%02x%02x", r * 255, g * 255, b * 255, a * 255))
end
local function GetItemLinkID(link)
	if type(link) == "string" then
		local itemId = link:match("|H.-:.-:(.-):")
		if itemId ~= nil then
			return tonumber(itemId)
		end
	end
	return nil
end
local function GetItemLinkItemLevel(itemLink)
	local level = GetItemLinkRequiredLevel(itemLink)
	if level == 50 then
		level = level + GetItemLinkRequiredVeteranRank(itemLink)
	end
	return level
end
local function GetItemQualityColor(quality)
--	return string.sub(RGBAToHex(GetInterfaceColor(INTERFACE_COLOR_TYPE_ITEM_QUALITY_COLORS, quality)),1,6)
	return COLOR_QUALITY[quality]
end
local function ControlChangeColor(control, hexColor)
	control:SetColor(HexToRGBA(hexColor)) 
end
local function isControlColorEgalTo(control, hexColor)
	-- local  r, g, b, a = control:GetColor()
	-- local  rf, gf, bf, af = HexToRGBA(hexColor)
	-- d(r..","..g..","..b..","..a)
	-- d(rf..","..gf..","..bf..","..af)
	-- return (r==rf and g==gf and b==bf and a==af)
	return string.sub(RGBAToHex(control:GetColor()), 1, 6) == string.sub(hexColor, 1, 6)
end
local function TableCopy(src, dest)
	dest = {}
	if type(src) == 'table' then
		for k, v in pairs(src) do
			if type(v) == 'table' then
				TableCopy(v, dest[k])
			end
			dest[k] = v
		end
	end
end
local function TableCount(src)
	local count = 0
	if type(src) == 'table' then
		for k,v in pairs(src) do
			count = count +1
		end
	end
	return count
end
local function getKeyByValue(t, value)
	for k,v in pairs(t) do
		if string.upper(v)==string.upper(value) then return k end
	end
	return nil
end
local function SignItemId(itemId)
--converts unsigned itemId to signed
	local SIGNED_INT_MAX = 2^32 / 2 - 1
	local INT_MAX 		 = 2^32
	if(itemId and itemId > SIGNED_INT_MAX) then
		itemId = itemId - INT_MAX
	end
	return itemId
end

local function addButton(parent, name, callbackFunction, text, font, tooltipText, tooltipAlign, textureNormal, textureMouseOver, textureClicked, color, width, height, left, top, alignValue, alignControl, alignControlValue, hideButton)
	--Add a button to an existing parent control (original code by Votan)
--	d("addButton "..name..","..tostring(hideButton))
	--Abort needed?
	if  (parent == nil or name == nil or callbackFunction == nil
		or width <= 0 or height <= 0 )
		and (textureNormal == nil or text == nil) then
			return nil
	end
	local button
    --Does the button already exist?
    button = WINDOW_MANAGER:GetControlByName(name, "")
    if button == nil then
        --Button does not exist yet and it should be hidden? Abort here!
        if hideButton == true then return nil end
        --Create the button control at the parent
        button = WINDOW_MANAGER:CreateControl(name, parent, CT_BUTTON)
    end
    --Button was created?
    if button ~= nil then
        -- -- Button should be hidden?
        -- if hideButton == false then
			local highlightColor = nil
			local isColorInitiated = false
			local defaultColor = color or COLOR_ICON
			button.color = defaultColor
            --Set the button's size
            button:SetDimensions(width, height)
            --Align the button
            if alignControl == nil then
                alignControl = parent
            end
            --SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
			if alignValue == nil then alignValue = TOPLEFT end
			if alignControlValue == nil then alignControlValue = TOPLEFT end
			button:ClearAnchors()
            button:SetAnchor(alignValue, alignControl, alignControlValue, left, top)
            --Texture or text?
            if (text ~= nil) then
                --Text
				button.type = "Label"
				highlightColor = COLOR_KHRILLSELECT
				local label
                 --Check if label exists
                label = WINDOW_MANAGER:GetControlByName(name .. "Label", "")
                if label == nil then
                    --Create the label for the button to hold the text
                    label = WINDOW_MANAGER:CreateControl(name .. "Label", button, CT_LABEL)
                end
				label:SetAnchorFill()
				label:SetVerticalAlignment(TEXT_ALIGN_CENTER)
				label:SetHorizontalAlignment(TEXT_ALIGN_CENTER)
                --Set the label's font
                if font == nil then
                    label:SetFont("ZoFontGameSmall")
                else
                    label:SetFont(font)
                end
                --Set the button's text
                label:SetText(text)
				--Set default color
				label.color = defaultColor
				label:SetColor(HexToRGBA(defaultColor))
				label:SetHidden(false)
            else
                --Texture
				button.type = "Texture"
                local texture
                 --Check if texture exists
                texture = WINDOW_MANAGER:GetControlByName(name .. "Texture", "")
                if texture == nil then
                    --Create the texture for the button to hold the image
                    texture = WINDOW_MANAGER:CreateControl(name .. "Texture", button, CT_TEXTURE)
                end
                texture:SetAnchorFill()
                --Set the texture for normale state now
                texture:SetTexture(textureNormal)
                --Do we have seperate textures for the button states?
				if textureMouseOver == nil and textureClicked == nil then
					highlightColor = COLOR_KHRILLSELECT
					isColorInitiated = (isControlColorEgalTo(texture, highlightColor))
				end
				texture.color = defaultColor
				texture:SetColor(HexToRGBA(defaultColor))
                button.upTexture      = textureNormal
                button.downTexture    = textureMouseOver or textureNormal
                button.clickedTexture = textureClicked or textureNormal
            end
			button.highlightColor = highlightColor
			button.isColorInitiated = isColorInitiated
            if tooltipAlign == nil then tooltipAlign = TOP end
            --Set a tooltip?
            if tooltipText ~= nil then
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    if self.downTexture then self:GetNamedChild("Texture"):SetTexture(self.downTexture) end
					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.highlightColor)) end
                    ZO_Tooltips_ShowTextTooltip(self, tooltipAlign, tooltipText)
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    if self.upTexture then self:GetNamedChild("Texture"):SetTexture(self.upTexture) end
					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.color)) end
                    ZO_Tooltips_HideTextTooltip()
					end)
				end
            else
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    if self.downTexture then self:GetNamedChild("Texture"):SetTexture(self.downTexture) end
 					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.highlightColor)) end
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    if self.upTexture then self:GetNamedChild("Texture"):SetTexture(self.upTexture) end
 					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.color)) end
					end)
				end
            end
            --Set the callback function of the button
            if button:GetHandler("OnClicked") == nil then button:SetHandler("OnClicked", function(butn)
				if butn.highlightColor ~= nil and not butn.isColorInitiated then butn:GetChild(1):SetColor(HexToRGBA(butn.color)) end
				butn.isColorInitiated = not(butn.isColorInitiated)
                callbackFunction()
				end)
			end
			if button:GetHandler("OnMouseDown") == nil then button:SetHandler("OnMouseDown", function(butn, ctrl, alt, shift, command)
				if butn.clickedTexture then butn:GetNamedChild("Texture"):SetTexture(butn.clickedTexture) end
				end)
			end
			--Show the button and make it react on mouse input
			button:SetHidden(hideButton) --false)
			button:SetMouseEnabled(not hideButton) --true)
			--Return the button control
			return button
		-- else
			-- --Hide the button and make it not reacting on mouse input
			-- button:SetHidden(true)
			-- button:SetMouseEnabled(false)
		-- end
	else
		return nil
	end
end
local function addEditbox(parent, name, callbackFunction, text)
	--build an editbox control (with label and edit zone)
	--Abort?
	if (parent == nil or name == nil) then
		return nil
	end

	local control
    --Does the control already exist?
    control = WINDOW_MANAGER:GetControlByName(name, "")
	if control == nil then
		control = WINDOW_MANAGER:CreateControl(name, parent, CT_CONTROL)
		control:SetMouseEnabled(true)
		control:SetResizeToFitDescendents(true)
		control:SetAnchor(TOPLEFT,parent,TOPLEFT,0,3)

		control.label = WINDOW_MANAGER:CreateControl(name.."Label", control, CT_LABEL)
		local label = control.label
		label:SetAnchor(TOPLEFT,control,TOPLEFT,0,2)
		label:SetFont("ZoFontWinT2")
		label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)

		control.bg = WINDOW_MANAGER:CreateControlFromVirtual(name.."BG", control, "ZO_EditBackdrop")
		local bg = control.bg

		control.editbox = WINDOW_MANAGER:CreateControlFromVirtual(name.."Editbox", bg, "ZO_DefaultEditForBackdrop")
		local editbox = control.editbox
		editbox:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		editbox:SetText("")
		editbox:SetMaxInputChars(100)
		if callbackFunction ~= nil then
			if editbox:GetHandler("OnFocusLost") == nil then editbox:SetHandler("OnFocusLost", function(self) callbackFunction() end) end
			if editbox:GetHandler("OnEscape") == nil then editbox:SetHandler("OnEscape", function(self) self:LoseFocus() callbackFunction() end) end
		end

		control:SetDimensions(280, 30)
		bg:SetDimensions(180, 24)
		bg:SetAnchor(TOPRIGHT, control, TOPRIGHT,0,0)
	end
	if text ~= nil then control.label:SetText(text) end
	control:SetHidden(false)
	
	return control
end
local function addSlider(parent, name, callbackFunction, minValue, maxValue, step, defaultValue, orientation, left, top, alignValue, alignControl, alignControlValue)
--d("--addSlider:"..name..","..minValue..","..maxValue..","..step..","..orientation)
	--add a slider with min and max text and label for selected
	--Abort needed?
	if (parent == nil or name == nil) then
		return nil
	end
	if orientation == nil then orientation = ORIENTATION_HORIZONTAL end
	
--	local myslider = WINDOW_MANAGER:CreateControlFromVirtual(name, parent, "ZO_Slider")
	local myslider = WINDOW_MANAGER:CreateControl(name, parent, CT_SLIDER)

	if orientation == ORIENTATION_HORIZONTAL then
		myslider:SetThumbTexture("EsoUI\\Art\\Miscellaneous\\scrollbox_elevator.dds", nil, nil, 16, 8)
		myslider:SetDimensions(200, 15)
	else
		myslider:SetThumbTexture("EsoUI\\Art\\Miscellaneous\\scrollbox_elevator.dds", nil, nil, 8, 16)
		myslider:SetDimensions(8, 205)
	end
	myslider:SetAnchor(alignValue, alignControl, alignControlValue, left, top)
	myslider:SetOrientation(orientation)
	myslider:SetMinMax(minValue,maxValue)
	myslider:SetValueStep(step) 
	myslider:SetValue(defaultValue) 
	myslider:SetMouseEnabled(true)
	if callbackFunction == nil then
		if myslider:GetHandler("OnValueChanged") == nil then myslider:SetHandler("OnValueChanged", function(self, value, eventReason)
				if eventReason == EVENT_REASON_SOFTWARE then return end
				self.selText:SetText(value)	
			end)
		end
	else
		if myslider:GetHandler("OnValueChanged") == nil then myslider:SetHandler("OnValueChanged", function(self, value, eventReason)
				if eventReason == EVENT_REASON_SOFTWARE then return end
				self.selText:SetText(value)
				callbackFunction()
			end)
		end
	end
	myslider:SetHidden(true)
	myslider:SetDrawLevel(2)
	myslider.bg = WINDOW_MANAGER:CreateControl(nil, myslider, CT_BACKDROP)
	local bg = myslider.bg
	bg:SetCenterColor(0, 0, 0)
	bg:SetAnchor(TOPLEFT, myslider, TOPLEFT, 0, 4)
	bg:SetAnchor(BOTTOMRIGHT, myslider, BOTTOMRIGHT, 0, -4)
	bg:SetEdgeTexture("EsoUI\\Art\\Tooltips\\UI-SliderBackdrop.dds", 32, 4)
	-- actual value label
	myslider.selText = WINDOW_MANAGER:CreateControl(nil, myslider, CT_LABEL)
	local selText = myslider.selText
	selText.Color=COLOR_KHRILLSELECT
	selText:SetFont("ZoFontGame")
	selText:SetColor(HexToRGBA(selText.Color))
	selText:SetAnchor(TOP, myslider, BOTTOM)
	selText:SetText(defaultValue)
	-- + & - buttons
	myslider.addBtn = WINDOW_MANAGER:CreateControl(nil, myslider, CT_BUTTON)
	local addBtn = myslider.addBtn
	addBtn.Color=COLOR_TEXT
	addBtn:SetDimensions(16, 16)
--	addBtn:SetColor(HexToRGBA(addBtn.Color))
	addBtn:SetNormalTexture(TEXTURE_ICON["Plus"])
	addBtn:SetAnchor(LEFT, myslider, RIGHT,0)
	if addBtn:GetHandler("OnClicked") == nil then addBtn:SetHandler("OnClicked", function(butn)
		KMC:OnCraftCountChange(1)
		end)
	end
	addBtn:SetHidden(false)
	addBtn:SetMouseEnabled(true)
	myslider.subBtn = WINDOW_MANAGER:CreateControl(nil, myslider, CT_BUTTON)
	local subBtn = myslider.subBtn
	subBtn.Color=COLOR_TEXT
	subBtn:SetDimensions(16, 16)
--	subBtn:SetColor(HexToRGBA(subBtn.Color))
	subBtn:SetNormalTexture(TEXTURE_ICON["Minus"])
	subBtn:SetAnchor(RIGHT, myslider, LEFT,0)
	if subBtn:GetHandler("OnClicked") == nil then subBtn:SetHandler("OnClicked", function(butn)
		KMC:OnCraftCountChange(-1)
		end)
	end
	subBtn:SetHidden(false)
	subBtn:SetMouseEnabled(true)
	-- min & max labels
	myslider.minText = WINDOW_MANAGER:CreateControl(nil, myslider, CT_LABEL)
	local minText = myslider.minText
	minText.Color=COLOR_TEXT
	minText:SetFont("ZoFontGameSmall")
	minText:SetColor(HexToRGBA(minText.Color))
	minText:SetAnchor(RIGHT, myslider, LEFT,-20)
	minText:SetText(minValue)
	myslider.maxText = WINDOW_MANAGER:CreateControl(nil, myslider, CT_LABEL)
	local maxText = myslider.maxText
	maxText.Color=COLOR_TEXT
	maxText:SetFont("ZoFontGameSmall")
	maxText:SetColor(HexToRGBA(maxText.Color))
	maxText:SetAnchor(LEFT, myslider, RIGHT,20)
	maxText:SetText(maxValue)

	return myslider
end

-- Other addons
local function WeaponChargeAlert_Hide(state)
	-- hide WCA when on station
	local addonWindow = GetControl("WeaponChargeAlert_Window")
	if addonWindow ~= nil then
		addonWindow:SetDrawLayer(DL_BACKGROUND)
		addonWindow:SetHidden(state)
	end
end
local function CheckforOtherAddons()
	--Check if other addons are activated
	-- Check for ItemSaver&FCOItemSaver addons
	if KMC.activeAddon.ItemSaver or ItemSaver_IsItemSaved ~= nil  then
		-- addon ItemSaver ok -> check if filter enable 
		KMC.itemSaverFilter = KMC.settings.ItemSaver
	end
    if KMC.activeAddon.FCOItemSaver or FCOIsMarked ~= nil then
    	-- addon FCOItemSaver ok -> check if enabled
		KMC.FCOitemSaverFilter = KMC.settings.FCOItemSaver
	end
end
local function checkItemSaved()
--d("--checkItemSaved")
	local defaults = {
		markedItems = {}
	}
	-- ItemSaver
	if KMC.activeAddon.ItemSaver then
		local ISsettings = ZO_SavedVars:NewAccountWide("ItemSaver_Settings", 2.0, nil, defaults)
--		local markedItems = ItemSaverSettings:GetMarkedItems()
--		for itemId, boolTrue in pairs(markedItems) do
		if ISsettings[1] ~= nil and ISsettings[1].savedItems ~= nil then
			for itemId, boolTrue in pairs(ISsettings[1].savedItems) do
				if boolTrue and KMC.accountSettings.ItemSaved[itemId] == nil then
					KMC.accountSettings.ItemSaved[itemId] = "?"
				elseif not boolTrue and KMC.accountSettings.ItemSaved[itemId] ~= nil then
					KMC.accountSettings.ItemSaved[itemId] = nil
				end
			end
		end
	end
	--FCOItemSaver
	if KMC.activeAddon.FCOItemSaver then
		local FCOsettings = ZO_SavedVars:NewAccountWide("FCOItemSaver_Settings", 0.10, "Settings", defaults)
		if FCOsettings[1] ~= nil and FCOsettings[1].markedItems ~= nil then
			for itemId, boolTrue in pairs(FCOsettings[1].markedItems) do
				if boolTrue and KMC.accountSettings.ItemSaved[itemId] == nil then
					KMC.accountSettings.ItemSaved[itemId] = "?"
				elseif not boolTrue and KMC.accountSettings.ItemSaved[itemId] ~= nil then
					KMC.accountSettings.ItemSaved[itemId] = nil
				end
			end
		end
	end
end
local function isItemLocked(link)
	local itemId = GetItemLinkID(link)
	local name = GetItemLinkName(link)
	local oldItemId = nil
	if KMC.accountSettings.ItemSaved[itemId] == nil then 
		-- find id correspondance (learned...)
		local otherItemId = getKeyByValue(KMC.accountSettings.ItemSaved, name)
		if otherItemId ~= nil then
			oldItemId = itemId
			itemId = otherItemId 
			KMC:msg("isItemLocked=>change "..oldItemId.." to  "..tostring(otherItemId)..","..tostring(KMC.accountSettings.ItemSaved[otherItemId]))
		end
	end
	if itemId ~= nil then
		local item = KMC.accountSettings.ItemSaved[itemId]
		if item ~= nil then 
--			d("======> true .."..item)
			if KMC.accountSettings.ItemSaved[GetItemLinkID(link)] == "?" then KMC.accountSettings.ItemSaved[GetItemLinkID(link)] = name end 
			if oldItemId ~= nil then KMC.accountSettings.ItemSaved[oldItemId] = name end
			return true
		elseif KMC.activeAddon.ItemSaver and KMC.settings.ItemSaverLock and ItemSaver_IsItemSaved(itemId) == true then --bagId, slotIndex) ~= nil then
--			d("-- itemSaver check")
			if item == nil or item == "?" then KMC.accountSettings.ItemSaved[itemId] = name end
			if oldItemId ~= nil then KMC.accountSettings.ItemSaved[oldItemId] = name end
			return true
		elseif KMC.activeAddon.FCOItemSaver and KMC.settings.FCOItemSaverLock and FCOIsMarked(itemId, -1) == true then
--			d("-- FCOitemSaver check")
			if item == nil or item == "?" then KMC.accountSettings.ItemSaved[itemId] = name end
			if oldItemId ~= nil then KMC.accountSettings.ItemSaved[oldItemId] = name end
			return true
		else
			return false
		end
	end
end

-- // **********
-- //  Inventory
-- // **********
function KMC:ScanBag(bagId)
	if KMC.selectedChar ~= KMC.activeChar then return end
	--Scan backpack&bank to find all ingredients
	KMC:msg("--scan bag="..tostring(bagId))
	if bagId == nil then
		KMC.Ingredients = {} --reinit
		local maxItem = 0
		maxItem = KMC:ScanBag(BAG_BACKPACK)
		if HasCraftBagAccess() then maxItem = maxItem + KMC:ScanBag(BAG_VIRTUAL) end
		maxItem = maxItem + KMC:ScanBag(BAG_BANK)
		if KMC.settings.sysmessage then
			local pattern = "<<1"..KMC.langString.MESSAGE_foundIngredient..">>"
			KMC:AddMessage(zo_strformat(pattern, maxItem), true)
		end
		return
	end
	CheckforOtherAddons()	

	local bagSlots = GetBagSize(bagId)
	local found = 0
	local slotIndex = ZO_GetNextBagSlotIndex(bagId, nil)
	while slotIndex do
	--for slotIndex = 0, bagSlots do
		local itemType = GetItemType(bagId, slotIndex)
		-- scan for ingredients
		if itemType == ITEMTYPE_INGREDIENT then --or itemType == ITEMTYPE_FLAVORING or itemType == ITEMTYPE_SPICE then
			local lock = false
			if KMC.itemSaverFilter and ItemSaver_IsItemSaved(bagId, slotIndex) == true then
--			d("itemsaver:"..zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagId, slotIndex)))
				-- itemSaver check
				lock = true
			elseif KMC.FCOitemSaverFilter and FCOIsMarked(GetItemInstanceId(bagId, slotIndex), -1) == true then
--			d("FCOitemSaver:"..zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagId, slotIndex)))
				-- FCOitemSaver check
				lock = true
			end
			local itemId = GetItemLinkID(GetItemLink(bagId, slotIndex))
			local itemName = zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagId, slotIndex))
			local icon, stack, sellPrice, meetsUsageRequirement, locked, equipType, itemStyle, quality  = GetItemInfo(bagId, slotIndex)		
--			local count = GetItemTotalCount(bagId, slotIndex)
			if KMC.Ingredients[itemId] ~= nil then
				stack = stack + KMC.Ingredients[itemId].count
			else
				found = found +1
			end
			KMC.Ingredients[itemId] = {name=itemName, icon=icon, quality=quality, count=stack, lock=lock}
		
		 --scan for locked consumable (food&drink) for saving them in memory (icon printed on UI)
		elseif (itemType == ITEMTYPE_FOOD or itemType == ITEMTYPE_DRINK) then
			local lock = false
			local itemId = SignItemId(GetItemInstanceId(bagId, slotIndex)) --GetItemLinkID(GetItemLink(bagId, slotIndex))
--			d("scan "..itemId..","..GetItemName(bagId, slotIndex))
			-- itemSaver check
			if KMC.activeAddon.ItemSaver and KMC.settings.ItemSaverLock and ItemSaver_IsItemSaved(bagId, slotIndex) == true then
--			d("itemsaver:"..zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagId, slotIndex)))
				lock = true
				if KMC.accountSettings.ItemSaved[itemId] == nil or KMC.accountSettings.ItemSaved[itemId] == "?" then KMC.accountSettings.ItemSaved[itemId] = GetItemName(bagId, slotIndex) end

			-- FCOitemSaver check
			elseif KMC.activeAddon.FCOItemSaver and KMC.settings.FCOItemSaverLock and FCOIsMarked(GetItemInstanceId(bagId, slotIndex), -1) == true then
--			d("FCOitemSaver:"..zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagId, slotIndex)))
				lock = true
				if KMC.accountSettings.ItemSaved[itemId] == nil or KMC.accountSettings.ItemSaved[itemId] == "?" then KMC.accountSettings.ItemSaved[itemId] = GetItemName(bagId, slotIndex) end
			end
			if not lock and KMC.accountSettings.ItemSaved[itemId] ~= nil then 
--			d("-> remove")
				KMC.accountSettings.ItemSaved[itemId] = nil
				local otherItemId = getKeyByValue(KMC.accountSettings.ItemSaved, GetItemName(bagId, slotIndex))
				if otherItemId ~= nil then KMC.accountSettings.ItemSaved[otherItemId] = nil end
			end
		end
		slotIndex = ZO_GetNextBagSlotIndex(bagId, slotIndex)
	end
	return found
end
function KMC:ShowIngredients(filter)
	-- display panel on screen for ingredients
	KMC:msg("--ShowIngredients")
	if filter == nil then
		if KMC.settings.saveFilter and KMC.settings.saveFilterValue ~= nil then
			filter = KMC.settings.saveFilterValue.ingredients
		else
			filter = {}
		end
	end
	local count = 0
	local item = ""
	local panelControl = GetControl("KMCUIItemList")
	local tempOrder = {}
	for ingredientId,Ingredient in pairs(KMC.Ingredients) do
		if KMC.settings.ingredientQuantity then -- order by quantity
			item = string.format("%03d", Ingredient.count)..Ingredient.name
		else -- or by name
			item = Ingredient.name
		end
		table.insert(tempOrder, item)
	end
	table.sort(tempOrder)
--	d(tempOrder)
	for _, compareName in pairs(tempOrder) do
		-- place ingredients in order by quantity
		for ingredientId,Ingredient in pairs(KMC.Ingredients) do
			if (KMC.settings.ingredientQuantity and compareName == string.format("%03d", Ingredient.count)..Ingredient.name) or (not(KMC.settings.ingredientQuantity) and compareName == Ingredient.name) then
				local posX = 50*(count%8)
				local posY = 50*(math.floor(count/8))
				local button = GetControl("KMC_Ingredient_"..tostring(ingredientId))
				if button == nil then
					button = CreateControlFromVirtual("KMC_Ingredient_", panelControl, "KMC_Item", tostring(ingredientId))
				end
				button:ClearAnchors()
				button:SetAnchor(TOPLEFT, panelControl, TOPLEFT, posX, posY)
				button:GetNamedChild("Outline"):SetTexture(TEXTURE_ICON["Outline"])
				button:GetNamedChild("Outline"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
				if filter[tostring(ingredientId)] ~= nil then button:GetNamedChild("Outline"):SetHidden(false) end --save filter select
				button:GetNamedChild("Texture"):SetTexture(Ingredient.icon)
				button:GetNamedChild("Number"):SetText(Ingredient.count)
				button.tip = Ingredient.name
				count = count +1
				if Ingredient.count == 0 then
					-- not in bag => disabled
		--			d("red:"..button:GetName())
					button:GetNamedChild("Texture"):SetColor(HexToRGBA(COLOR_DISABLED))
				elseif Ingredient.lock then -- lock by other addon
					button:GetNamedChild("Texture"):SetColor(HexToRGBA(COLOR_LOCK))
				else
					button:GetNamedChild("Texture"):SetColor(HexToRGBA(COLOR_ICON))
				end
			end
		end
	end
end
function KMC:resetIngredients()
	--d("--resetIngredients")
	for i=1,KMCUIItemList:GetNumChildren() do
		local controlName = KMCUIItemList:GetChild(i):GetName()
		if string.find(controlName, "KMC_Ingredient_") ~= nil then
			-- pour chaque ingredient, on remet les items en non selectionné (outline)
			local control = GetControl(controlName.."Outline")
			control:SetHidden(true)
		end
	end
end

function KMC_Item_showTip(resultButton, state)
	if state then
		ZO_Tooltips_ShowTextTooltip(resultButton, BOTTOM, "|c"..COLOR_KHRILLSELECT..resultButton.tip.."|r")
	else
		ZO_Tooltips_HideTextTooltip()	
	end
end
function KMC_Item_select(resultButton)
	resultButton:GetNamedChild("Outline"):SetHidden(not resultButton:GetNamedChild("Outline"):IsControlHidden())
end


-- // **********
-- //  Recipes
-- // **********
--[[ ProvisionerSpecialIngredientType
# PROVISIONER_SPECIAL_INGREDIENT_TYPE_FLAVORING 2  
# PROVISIONER_SPECIAL_INGREDIENT_TYPE_NONE 0  
# PROVISIONER_SPECIAL_INGREDIENT_TYPE_SPICES 1  
]]

function KMC:ScanRecipes()
	if KMC.selectedChar ~= KMC.activeChar then return end
	-- Scan recipes into memory
	local found = 0
	local numKnown = 0
	local numSteps, numConditions
	local selCraft
	KMC:msg("--scan recipes="..GetNumRecipeLists(), false)
	local Recipes = {}

	for recipeListIndex=1, #KMC.RecipeList do
		local numRecipes = KMC.RecipeList[recipeListIndex].count
		KMC:msg("Liste "..recipeListIndex..":"..zo_iconFormat(KMC.RecipeList[recipeListIndex].icon, 16, 16)..KMC.RecipeList[recipeListIndex].name.. ","..numRecipes)
		Recipes = {} --reinit for next category
		numKnown = 0
		for recipeIndex=1,numRecipes do
			--GetRecipeInfo(luaindex recipeListIndex, luaindex recipeIndex)
			--Returns: bool known, string name, integer numIngredients, integer provisionerLevelReq, integer qualityReq, ProvisionerSpecialIngredientType specialIngredientType
--d(GetRecipeInfo(recipeListIndex, recipeIndex))
			local known, name, numIngredients, provisionerLevelReq, qualityReq, specialIngredientType = GetRecipeInfo(recipeListIndex, recipeIndex)
			if known then --known recipe only
				numKnown = numKnown +1
				local isEnable = ZO_SharedProvisioner:PassesProvisionerLevelReq(provisionerLevelReq) and ZO_SharedProvisioner:PassesQualityLevelReq(qualityReq)
--				isEnable = provisionerLevelReq <= GetNonCombatBonus(NON_COMBAT_BONUS_PROVISIONING_LEVEL) and qualityReq <= GetNonCombatBonus(NON_COMBAT_BONUS_PROVISIONING_RARITY_LEVEL)
				--GetRecipeResultItemInfo(luaindex recipeListIndex, luaindex recipeIndex)
				--Returns: string name, textureName icon, integer stack, integer sellPrice, integer quality
--				d(GetRecipeResultItemInfo(recipeListIndex, recipeIndex))
				local recipeName, recipeIcon, stack,  sellPrice, recipeQuality = GetRecipeResultItemInfo(recipeListIndex, recipeIndex)
				recipeName = zo_strformat(SI_TOOLTIP_ITEM_NAME, recipeName)
				KMC:msg("* "..recipeIndex..":"..zo_iconFormat(recipeIcon, 16, 16).."|c"..GetItemQualityColor(recipeQuality)..recipeName.."|r,"..numIngredients.. ","..provisionerLevelReq.. ","..qualityReq.. ","..specialIngredientType)
				local link = GetRecipeResultItemLink(recipeListIndex, recipeIndex, LINK_STYLE_DEFAULT)
				local itemId = GetItemLinkID(link)
	--d(link..":")
	--d(ZO_LinkHandler_ParseLink(link))
				local itemLocked = isItemLocked(link)
				local hasAbility, abilityHeader, abilityDescription, cooldown = GetItemLinkOnUseAbilityInfo(link)
				local itemLevel = GetItemLinkItemLevel(link)
--				local oldmaxCount = ZO_SharedProvisioner:CalculateHowManyCouldBeCreated(recipeListIndex, recipeIndex, numIngredients) --crash in DE client (?)
				local maxCount
				Recipes[recipeIndex] = { known=known, enable=isEnable, lock=false, ingredientType=specialIngredientType, listIndex=recipeListIndex, index=recipeIndex, name=recipeName, icon=recipeIcon, level=provisionerLevelReq, quality=recipeQuality, itemId=itemId, itemLink=link, itemEffect=abilityDescription, itemLevel=itemLevel, itemLocked = itemLocked, count=0, ingredients={} }
				found = found +1
				-- with ingredients (and count calculation)
				for ingredientIndex=1,numIngredients do
					--GetRecipeIngredientItemInfo(luaindex recipeListIndex, luaindex recipeIndex, luaindex ingredientIndex) 
					--Returns: string name, textureName icon, integer requiredQuantity, integer sellPrice, integer quality
					local ingredientName, icon, requiredQuantity, sellPrice, quality = GetRecipeIngredientItemInfo(recipeListIndex, recipeIndex, ingredientIndex) 
					local ingredientId = GetItemLinkID(GetRecipeIngredientItemLink(recipeListIndex, recipeIndex, ingredientIndex, LINK_STYLE_DEFAULT))
					local ingredientCount = GetCurrentRecipeIngredientCount(recipeListIndex, recipeIndex, ingredientIndex)
					KMC:msg("--> "..ingredientIndex..":"..zo_iconFormat(icon, 16, 16)..ingredientName.. " par "..requiredQuantity.." ("..ingredientCount..")", false)
					Recipes[recipeIndex].ingredients[ingredientIndex]={id=ingredientId, name=ingredientName, icon=icon, quality=quality, quantity=requiredQuantity}
					--check if ingredient is in DB => if not, add with count=0
					if KMC.Ingredients[ingredientId] == nil then
						KMC.Ingredients[ingredientId] = {name=zo_strformat(SI_TOOLTIP_ITEM_NAME, ingredientName), icon=icon, quality=quality, count=0, lock=false}
					elseif KMC.Ingredients[ingredientId].lock then --lock by other addon
						Recipes[recipeIndex].lock = true
					end
					--update recipe counter
					 maxCount = zo_min(zo_floor(ingredientCount/requiredQuantity), maxCount or math.huge) 
				end
				Recipes[recipeIndex].count = maxCount or 0
--	if oldmaxCount ~= maxCount then
--		d("* "..recipeIndex..":"..tostring(recipeName).."|r,"..tostring(numIngredients).. ":"..tostring(oldmaxCount).. "!="..tostring(maxCount))
--	end
			end
		end
		KMC.RecipeList[recipeListIndex].recipes = Recipes
		KMC.RecipeList[recipeListIndex].known = numKnown
	end
	KMC.maxRecipes = found
	KMC:msg("--end scan", false)
	KMC:msg("activeChar: "..tostring(KMC.activeChar))
	if KMC.settings.sysmessage then
		local pattern = "<<1"..KMC.langString.MESSAGE_foundRecipe..">>"
		KMC:AddMessage(zo_strformat(pattern, found), true)
	end

	--save Recipes into Global DB
	KMC.settings.Recipes = KMC.RecipeList
	if KMC.GlobalRecipes[KMC.activeChar] == nil then
		KMC.GlobalRecipes[KMC.activeChar] = {}
		KMC.GlobalRecipes[KMC.activeChar].classId = GetUnitClassId("player")
		table.insert(KMC.characterList, KMC.activeChar)
	end
--	TableCopy(KMC.RecipeList, KMC.GlobalRecipes[KMC.activeChar].Recipes)
	KMC.GlobalRecipes[KMC.activeChar].Recipes = KMC.RecipeList
end
function KMC:ShowRecipes(filtersList,recipeOrder,ingredientsList,writRecipes)
	-- display panel on screen for recipes
	KMC:msg("--showRecipes")
	if writRecipes ~= nil then
		-- get all recipes
		writRecipes = string.gsub(string.lower(writRecipes),"-", "")
		filtersList = {}
		recipeOrder = "3"
		ingredientsList = {}
	else
		if filtersList == nil then
			if KMC.settings.saveFilter and KMC.settings.saveFilterValue ~= nil then
				filtersList = KMC.settings.saveFilterValue.filters
			else
				filtersList = {}
			end
		end
		if recipeOrder == nil then
			if KMC.settings.saveFilter and KMC.settings.saveFilterValue ~= nil then
				recipeOrder = KMC.settings.saveFilterValue.order
			else
				recipeOrder = "3"
			end
		else
			recipeOrder = tostring(recipeOrder)
		end
		if ingredientsList == nil then
			if KMC.settings.saveFilter and KMC.settings.saveFilterValue ~= nil then
				ingredientsList = KMC.settings.saveFilterValue.ingredients
			else
				ingredientsList = {}
			end
		end
	end
	-- init KMC.RecipesESOTree for ESO recipes UI
	KMC.RecipesESOTree[PROVISIONER_SPECIAL_INGREDIENT_TYPE_SPICES] = nil
	KMC.RecipesESOTree[PROVISIONER_SPECIAL_INGREDIENT_TYPE_FLAVORING] = nil

	local count = 1
	local index = 1
	local item = ""
	local tempOrder = {}
	for listIndex=1,#KMC.RecipeList do
		for recipeIndex,Recipe in pairs(KMC.RecipeList[listIndex].recipes) do
			if writRecipes ~= nil then --writ quest mode
				--check requested recipes for writ quest
				if zo_strfind(writRecipes, string.gsub(string.lower(Recipe.name),"-", "")) ~= nil then
					table.insert(tempOrder, string.format("%02d", listIndex).."-"..Recipe.level..Recipe.name)
				end
			else --filtering
				--ingredients filtering
				filterItem = (TableCount(ingredientsList)==0)
				if ingredientsList~= nil then
					for k,v in pairs(Recipe.ingredients) do
						if ingredientsList[v.id] ~= nil then filterItem = true end
					end
				end			
				if filterItem then
					--filter 1 = category
					if (filtersList["1"]==nil or filtersList["1"][tostring(Recipe.listIndex)]==true) then
						-- filter 2 = effect
						if (filtersList["2"]==nil or filtersList["2"]["0"]==nil or string.find(KMC.RecipeEffect[tonumber(Recipe.listIndex)], filtersList["2"]["0"]) ~= nil ) then
							-- filter 3 = level
							local filter3 = false
							if filtersList["3"]~= nil then
								local testLevelMin = 0
								local testLevelMax = 99
								for k,v in pairs(filtersList["3"]) do
									if Recipe.itemLevel >= KMC.RecipeLevel[tonumber(k)] and Recipe.itemLevel < KMC.RecipeLevel[tonumber(k+1)] then filter3 = true end
								end
							end
							if (filtersList["3"]==nil or filter3) then
								--filter 4 = search
								if (filtersList["4"]==nil or filtersList["4"]["0"]==nil or string.find(string.lower(Recipe.name),  string.lower(filtersList["4"]["0"])) ~= nil ) then
									--and order
									if recipeOrder == "1" then --name
										item = Recipe.name
									elseif recipeOrder == "2" then --level
--										if KMC.settings.itemLevel then
											item = string.format("%02d", Recipe.itemLevel)..Recipe.name
--										else
--											item = Recipe.level..Recipe.name
--										end
									elseif recipeOrder == "4" then --quantity
										item = string.format("%03d", 1000-Recipe.count)..Recipe.name									
									else -- category / level / name (default)
										item = string.format("%02d", listIndex).."-"..Recipe.level..Recipe.name
									end
									table.insert(tempOrder, item)
								end
							end
						end
					end
				end
			end
		end
	end
	table.sort(tempOrder)
--	d(tempOrder)
	KMC:CleanUI()
	for _, compareName in pairs(tempOrder) do
		-- place recipes in order
		for listIndex=1,#KMC.RecipeList do
			for recipeIndex,Recipe in pairs(KMC.RecipeList[listIndex].recipes) do
				if (recipeOrder == "1" and compareName == Recipe.name) or (recipeOrder == "2" and compareName == string.format("%02d", Recipe.itemLevel)..Recipe.name) or (recipeOrder == "3" and compareName == string.format("%02d", listIndex).."-"..Recipe.level..Recipe.name) or (recipeOrder == "4" and compareName == string.format("%03d", 1000-Recipe.count)..Recipe.name) then
					local controlName = "KMC_RecipePanel_"..tostring(count)
--					local controlName = "KMC_RecipePanel_"..tostring(listIndex).."_"..tostring(recipeIndex)
					local panelControl = GetControl(controlName)
					if panelControl == nil then
						panelControl = CreateControlFromVirtual("KMC_RecipePanel_", KMCUIRecipeList, "KMC_RecipePanel", tostring(count))
--						panelControl = CreateControlFromVirtual("KMC_RecipePanel_", KMCUIRecipeList, "KMC_RecipePanel", tostring(listIndex).."_"..tostring(recipeIndex))
						if panelControl:GetHandler("OnMouseWheel") == nil then panelControl:SetHandler("OnMouseWheel", function(self, delta) KMC:OnMouseWheel(delta) end) end
					end
					panelControl:ClearAnchors()
					panelControl:SetAnchor(TOPLEFT, KMCUIRecipeList, TOPLEFT, 0, (30*(count-1))+8)
				
					local iconControl = GetControl(controlName.."Icon")
					iconControl:SetTexture(Recipe.icon)
					GetControl(controlName.."Number"):SetText(Recipe.count)
					-- place recipe name
					local labelControl = GetControl(controlName.."Label")
					if KMC.settings.itemLevel then
						labelControl:SetText("["..Recipe.itemLevel.."] "..string.sub(Recipe.name,1,33))
					else
						labelControl:SetText("["..Recipe.level.."] "..string.sub(Recipe.name,1,34))
					end
					-- check selected/valid/lock?
					if KMC.selectedRecipe~=nil and Recipe.ingredientType == KMC.selectedRecipe.Recipe.ingredientType and Recipe.listIndex == KMC.selectedRecipe.Recipe.listIndex and Recipe.index == KMC.selectedRecipe.Recipe.index then
--d("selected="..KMC.selectedRecipe.Recipe.name..":"..KMC.selectedRecipe.Recipe.ingredientType..","..KMC.selectedRecipe.Recipe.listIndex..","..KMC.selectedRecipe.Recipe.index)
--d("tested="..Recipe.name..":"..Recipe.ingredientType..","..Recipe.listIndex..","..Recipe.index)
						iconControl:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
						labelControl:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
						KMC.selectedRecipe.Recipe.count = Recipe.count
						-- update multicraft slider maxnumber
						local nbItem = tonumber(Recipe.count)
						local sliderControl = GetControl("KMCUICraftCount")
						sliderControl:SetMinMax(1, nbItem)
						sliderControl.maxText:SetText(nbItem)			
					elseif not Recipe.enable then
						iconControl:SetColor(HexToRGBA(COLOR_DISABLED))
						labelControl:SetColor(HexToRGBA(COLOR_DISABLED)) 
					elseif Recipe.lock then -- ingredient lock by other addon
						iconControl:SetColor(HexToRGBA(COLOR_LOCK))
						labelControl:SetColor(HexToRGBA(COLOR_LOCK)) 
					else
						iconControl:SetColor(HexToRGBA(COLOR_NOCOLOR))
						labelControl:SetColor(HexToRGBA(GetItemQualityColor(Recipe.quality))) 
					end
					-- result item icon lock
					GetControl(controlName.."Lock"):SetHidden(not Recipe.itemLocked)
					-- tip
					panelControl.Recipe = Recipe
					panelControl:SetHidden(count>KMC.maxRow)
					count = count +1
				end
			end
		end
	end
	KMC.maxRecipes = count -1
	--scroll slider
	KMCUIRecipeSlider:SetMinMax(1,KMC.maxRecipes-KMC.maxRow+1)
	KMCUIRecipeSlider:SetValue(1)
	if KMC.settings.sysmessage then
		local pattern = "<<1"..KMC.langString.MESSAGE_printedRecipe..">>"
		KMC:AddMessage(zo_strformat(pattern, KMC.maxRecipes))
	end
end
function KMC:UpdateRecipes()
	-- update printed recipes with scroll slider position
	KMC:msg("UpdateRecipes: offset="..KMC.sliderOffset)
	for i= 1, KMC.maxRecipes do
		local panelControl = GetControl("KMC_RecipePanel_"..tostring(i))
		if i >= KMC.sliderOffset and i <= KMC.maxRow+KMC.sliderOffset-1 then
			panelControl:ClearAnchors()
			panelControl:SetAnchor(TOPLEFT, KMCUIRecipeList, TOPLEFT, 0, (30*(i-KMC.sliderOffset))+8)
			panelControl:SetHidden(false)
		else
			panelControl:SetHidden(true)
		end
	end
end
function KMC:SelectRecipe(button)
	--change selected recipe label&icon color
	if KMC.selectedRecipe ~= nil then
		if not KMC.selectedRecipe.Recipe.enable then
			KMC.selectedRecipe:GetNamedChild("Label"):SetColor(HexToRGBA(COLOR_DISABLED))
			KMC.selectedRecipe:GetNamedChild("Icon"):SetColor(HexToRGBA(COLOR_DISABLED)) 
		elseif KMC.selectedRecipe.Recipe.lock then
			KMC.selectedRecipe:GetNamedChild("Label"):SetColor(HexToRGBA(COLOR_LOCK))
			KMC.selectedRecipe:GetNamedChild("Icon"):SetColor(HexToRGBA(COLOR_LOCK)) 
		else
			KMC.selectedRecipe:GetNamedChild("Label"):SetColor(HexToRGBA(GetItemQualityColor(KMC.selectedRecipe.Recipe.quality)))
			KMC.selectedRecipe:GetNamedChild("Icon"):SetColor(HexToRGBA(COLOR_NOCOLOR))
		end
	end
	button:GetNamedChild("Label"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
	button:GetNamedChild("Icon"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
--		button:GetChild(1):SetTexture(button.Recipe.icon)
	KMC.selectedRecipe = button
end
function KMC_ShowStatRecipes()
	KMC:AddMessage("|c"..COLOR_KHRILLSELECT..KMC.selectedChar.."|r - Stats :")
	local totalRecipe = 0
	local totalKnown = 0
	for recipeListIndex=1, GetNumRecipeLists() do
		if KMC.RecipeList[recipeListIndex] ~= nil then
			if KMC.RecipeList[recipeListIndex].known == nil then KMC.RecipeList[recipeListIndex].known = "?" end
			local color = COLOR_QUALITY[2]
			if KMC.RecipeQuality[recipeListIndex] ~= nil then color = GetItemQualityColor(KMC.RecipeQuality[recipeListIndex]) end
			KMC:AddMessage(zo_iconFormat(KMC.RecipeList[recipeListIndex].icon, 24, 24).." |c"..color..KMC.RecipeList[recipeListIndex].name.. "|r : "..KMC.RecipeList[recipeListIndex].known.."/"..KMC.RecipeList[recipeListIndex].count)
			totalKnown = totalKnown + KMC.RecipeList[recipeListIndex].known
			totalRecipe = totalRecipe + KMC.RecipeList[recipeListIndex].count
			
			if KMC.settings.statLvl then
				--with detail by level
				local byLevel={}
				for recipeIndex=1,KMC.RecipeList[recipeListIndex].count do
					local known, name, numIngredients, provisionerLevelReq, qualityReq, specialIngredientType = GetRecipeInfo(recipeListIndex, recipeIndex)
					if not byLevel[provisionerLevelReq] then
						byLevel[provisionerLevelReq] = {}
						byLevel[provisionerLevelReq].count = 0
						byLevel[provisionerLevelReq].known = 0
					end
					byLevel[provisionerLevelReq].count = byLevel[provisionerLevelReq].count +1
					if known then byLevel[provisionerLevelReq].known = byLevel[provisionerLevelReq].known +1 end
				end
				for k,v in pairs(byLevel) do
					if k ==0 then
						KMC:AddMessage("-> "..KMC.langString.TEXT_unknown.." = "..v.count)
					else
						if KMC.RecipeCount[recipeListIndex] ~= nil and KMC.RecipeCount[recipeListIndex][k] ~= nil and KMC.RecipeCount[recipeListIndex][k] == v.count then
							KMC:AddMessage("-> |c"..COLOR_KHRILLSELECT..KMC.langString.TEXT_Filter[3].." "..k.." = "..v.count.."|r")
						else
							KMC:AddMessage("-> "..KMC.langString.TEXT_Filter[3].." "..k.." = "..v.count)
						end
					end
				end
			end
		end
	end
	KMC:AddMessage("|c"..COLOR_KHRILLSELECT..KMC.selectedChar.."|r - Total : "..totalKnown.."/"..totalRecipe)
end

function KMC_Recipe_showTip(resultButton, state)
	--show/hide recipe tooltip in list
	if state then
		local tooltipText = resultButton.Recipe.itemEffect
--		if KMC.onStation then
--			ZO_Tooltips_ShowTextTooltip(resultButton, BOTTOM, tooltipText)
--		else
			tooltipText = tooltipText .."\n\n"..GetString(SI_PROVISIONER_INGREDIENTS_HEADER).." :"

			for ingredientIndex, Ingredient in pairs (resultButton.Recipe.ingredients) do
				if Ingredient.quality == nil then Ingredient.quality = 1 end
				tooltipText = tooltipText .."\n   "..Ingredient.quantity.."x "..zo_iconFormat(Ingredient.icon, 20, 20)..zo_strformat(SI_TOOLTIP_ITEM_NAME, "|c"..GetItemQualityColor(Ingredient.quality)..Ingredient.name.."|r") --Ingredient.name
			end
			ZO_Tooltips_ShowTextTooltip(resultButton, BOTTOM, tooltipText)
--		end
	else
		ZO_Tooltips_HideTextTooltip()	
	end
end
function KMC_Recipe_select(resultButton)
--	d("--Recipe_select:"..zo_iconFormat(resultButton.Recipe.icon, 16, 16).."|c"..GetItemQualityColor(resultButton.Recipe.quality)..resultButton.Recipe.name.."|r,")
	if KMC.onStation then -- fireplace => ESO UI
		if not IsPerformingCraftProcess() then
			--select correct tab in ESO UI
			while ZO_MenuBar_GetSelectedDescriptor(ZO_ProvisionerTopLevelTabs) ~= resultButton.Recipe.ingredientType do
				ZO_MenuBar_SelectDescriptor(ZO_ProvisionerTopLevelTabs, resultButton.Recipe.ingredientType)
				_G["ZO_ProvisionerTopLevelTooltip"]:SetHidden(true)
			end
			KMC:SelectRecipe(resultButton)
			zo_callLater(function() KMC:findRecipe(resultButton) end,200) --wait for refreshing ESO UI
		end
	else -- not at a fireplace => show tooltip
		KMC:SelectRecipe(resultButton)
		PlaySound(SOUNDS.PROVISIONING_ENTRY_SELECTED)
		KMC:ShowTooltip(true)
	end
end
function KMC:findRecipe(resultButton)
--d("findRecipe")
	--find recipe in ESO tree
	local nodeControlName = KMC:FindESOTree(resultButton.Recipe.ingredientType, resultButton.Recipe.listIndex, resultButton.Recipe.index)
	if nodeControlName ~= nil then --find it
--		KMC:SelectRecipe(resultButton)
		--select node in ESO UI
		local treeNode = _G[nodeControlName].node
--		d(zo_strformat(SI_TOOLTIP_ITEM_NAME, treeNode.data.name)..","..treeNode.data.recipeListIndex..","..treeNode.data.recipeIndex)
		KMC:ShowTooltip(false)
		PlaySound(treeNode.selectSound)
		treeNode:GetTree():SelectNode(treeNode)
		_G["ZO_ProvisionerTopLevelTooltip"]:SetHidden(false)
		--hide craft button & multicraft slider if locked
		if resultButton.Recipe.lock then
			KEYBIND_STRIP:RemoveKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor)
			KMCUICraftCount:SetHidden(true)
		else
			KEYBIND_STRIP:AddKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor)
			local control = GetControl("KMCUICraftCount")
			control:SetValue(1)
			control.selText:SetText(1)
			control:SetMinMax(1, resultButton.Recipe.count)
			control.maxText:SetText(resultButton.Recipe.count)
			control:SetHidden(false)
		end
	else --not known by character
		_G["ZO_ProvisionerTopLevelTooltip"]:SetHidden(true)
		KEYBIND_STRIP:RemoveKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor)
		PlaySound(SOUNDS.PROVISIONING_ENTRY_SELECTED)
		KMC:ShowTooltip(true)
	end
end
function KMC:ScanESOTree(ingredientType)
	--Scan ESO tree and memorize recipes
--	d("--ScanESOTree:"..ingredientType)
	local i=1
	KMC.RecipesESOTree[ingredientType] = {}
	local nameZone = "ZO_ProvisionerTopLevelNavigationContainerScrollChildZO_ProvisionerNavigationEntry" .. tostring(i)
	while GetControl(nameZone) ~= nil do
		local node = GetControl(nameZone).node
		KMC.RecipesESOTree[ingredientType][nameZone] = {listIndex=node.data.recipeListIndex, recipeIndex=node.data.recipeIndex, name=zo_strformat(SI_TOOLTIP_ITEM_NAME, node.data.name)}
		i=i+1
		nameZone = "ZO_ProvisionerTopLevelNavigationContainerScrollChildZO_ProvisionerNavigationEntry" .. tostring(i)
	end
end
function KMC:FindESOTree(ingredientType, recipeListIndex, recipeIndex)
--	d("--FindESOTree: "..tostring(ingredientType)..","..tostring(recipeListIndex)..","..tostring(recipeIndex).."="..tostring((KMC.RecipesESOTree[ingredientType])==nil))
--	d(KMC.RecipesESOTree[ingredientType])
	if KMC.RecipesESOTree == nil or KMC.RecipesESOTree[ingredientType] == nil then KMC:ScanESOTree(ingredientType) end --not yet scan
	
	for k,v in pairs(KMC.RecipesESOTree[ingredientType]) do
--		d("check "..k..","..v.name)
		if v.listIndex == recipeListIndex and v.recipeIndex == recipeIndex then
--			d("=> "..k)
			return k --found
		end
	end
	return nil --not found
end


-- // **********
-- //  Filter
-- // **********

function KMC:addFilterPanel()
	-- display filter panel on left of the book
	local saveFilterValue = nil
	if KMC.settings.saveFilter then 
		saveFilterValue = {}
		saveFilterValue = KMC.settings.saveFilterValue
	end

	for position=1,#KMC.langString.TEXT_Filter do
		local filterName = KMC.langString.TEXT_Filter[position]
--		d("--addFilterPanel:"..filterName..","..position)
		local panelControl = GetControl("KMC_RecipeFilter_"..tostring(position))
		if panelControl == nil then
			panelControl = CreateControlFromVirtual("KMC_RecipeFilter_", KMCUIRecipe, "KMC_RecipeFilter", tostring(position))
		end
		-- replace panel in function of the previous
		local delta = 0 
		if position > 1 then
			if GetControl("KMC_RecipeFilter_"..tostring(position-1).."List") ~= nil then
				local _, _, _, _, offsetX, offsetY = GetControl("KMC_RecipeFilter_"..tostring(position-1)):GetAnchor()
				delta = offsetY+GetControl("KMC_RecipeFilter_"..tostring(position-1).."List"):GetHeight()+40
			end
		end
		panelControl:ClearAnchors()
		panelControl:SetAnchor(TOPLEFT, KMCUIRecipe, TOPLEFT, 30, 20+delta)
		
		-- place filter name
		local labelControl = GetControl("KMC_RecipeFilter_"..tostring(position).."Label")
		labelControl:SetText(KMC.langString.TEXT_Filter[position])
		
		-- and all items
		local filterListControl = GetControl("KMC_RecipeFilter_"..tostring(position).."List")
		local posX, posY
		if tostring(position) == FILTER_CATEGORY then -- recipes type (14) (15?)
			filterListControl:SetDimensions(280,60)
			for recipeListIndex=1, #KMC.RecipeList do
				if recipeListIndex <8 then
					posX = 32*((recipeListIndex-1)%7)
					posY = 0 --30*(math.floor((recipeListIndex-1)/7))
				elseif recipeListIndex ==16 then --food epic
					posX = 32*((7)%8)
					posY = 0 --30*(math.floor((recipeListIndex-1)/7))
				else
					posX = 32*((recipeListIndex-1-7)%8)
					posY = 30 --*(math.floor((recipeListIndex-1)/8))
				end
				local color = nil
				if KMC.RecipeQuality[recipeListIndex] ~= nil then color = GetItemQualityColor(KMC.RecipeQuality[recipeListIndex]) end
				local button = addButton(filterListControl, "KMC_RecipeFilter_"..tostring(position).."List"..recipeListIndex, function(...) KMC_ToggleFilterItem(position,recipeListIndex) end, nil, nil, "|c"..COLOR_KHRILLSELECT..KMC.RecipeList[recipeListIndex].name.."|r", BOTTOM, KMC.RecipeList[recipeListIndex].icon, nil, nil, color, 32, 32, posX, posY, TOPLEFT, filterListControl, TOPLEFT, false)
				if KMC.settings.saveFilter and saveFilterValue~= nil and saveFilterValue.filters[tostring(position)]~=nil and saveFilterValue.filters[tostring(position)][tostring(recipeListIndex)]~=nil then
					button:GetNamedChild("Texture"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
					button.isColorInitiated = true
				end
			end
		elseif tostring(position) == FILTER_EFFECT then -- food effect (max or regen stats)
			local tipEffect = {
				[1]=KMC.langString.TEXT_max.." "..KMC.langString.TEXT_health,
				[2]=KMC.langString.TEXT_max.." "..KMC.langString.TEXT_magicka,
				[3]=KMC.langString.TEXT_max.." "..KMC.langString.TEXT_stamina,
				[4]=KMC.langString.TEXT_regen.." "..KMC.langString.TEXT_health,
				[5]=KMC.langString.TEXT_regen.." "..KMC.langString.TEXT_magicka,
				[6]=KMC.langString.TEXT_regen.." "..KMC.langString.TEXT_stamina,
			}
			for i=1,6 do
				local posX = 32*(i-1)
				local posY = 0
				local button = addButton(filterListControl, "KMC_RecipeFilter_"..tostring(position).."List"..i, function(...) KMC_ToggleFilterItem(position,i) end, nil, nil, "|c"..COLOR_KHRILLSELECT..tipEffect[i].."|r", BOTTOM, TEXTURE_ICON["Effect"..i], nil, nil, nil, 32, 32, posX, posY, TOPLEFT, filterListControl, TOPLEFT, false)
				if KMC.settings.saveFilter and saveFilterValue~= nil and saveFilterValue.filters[tostring(position)]~=nil and string.find(tostring(i),saveFilterValue.filters[tostring(position)]["0"])~=nil then
					button:GetNamedChild("Texture"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
					button.isColorInitiated = true
				end
			end
		elseif tostring(position) == FILTER_LEVEL then -- recipes result lvl
			for i=1,7 do
				local posX = 40*(i-1)
				local posY = 0
				local button = addButton(filterListControl, "KMC_RecipeFilter_"..tostring(position).."List"..i, function(...) KMC_ToggleFilterItem(position,i) end, KMC.RecipeLevelLabel[i], nil, nil, BOTTOM, nil, nil, nil, nil, 32, 32, posX, posY, TOPLEFT, filterListControl, TOPLEFT, false)
				if KMC.settings.saveFilter and saveFilterValue~= nil and saveFilterValue.filters[tostring(position)]~=nil and saveFilterValue.filters[tostring(position)][tostring(i)]~=nil then
					button:GetNamedChild("Label"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
					button.isColorInitiated = true
				end
			end	
		elseif tostring(position) == FILTER_SEARCH then -- search area
			--(parent, name, callbackFunction, text)
			local control = addEditbox(filterListControl, "KMC_RecipeFilter_"..tostring(position).."Search", nil, KMC.langString.TEXT_recipes)
			if KMC.settings.saveFilter and saveFilterValue~= nil and saveFilterValue.filters[tostring(position)]~=nil and saveFilterValue.filters[tostring(position)]["0"]~=nil then
				control.editbox:SetText(saveFilterValue.filters[tostring(position)]["0"])
			end
		elseif tostring(position) == FILTER_SORT then -- sort items
			-- sort=name, level, category
			for i=1,#KMC.langString.TEXT_Sort do
				local posX = 70*(i-1)
				local posY = 0
				local button = addButton(filterListControl, "KMC_RecipeFilter_"..tostring(position).."List"..i, function(...) KMC_ToggleFilterItem(position,i) end, KMC.langString.TEXT_Sort[i], nil, nil, BOTTOM, nil, nil, nil, nil, 60, 32, posX, posY, TOPLEFT, filterListControl, TOPLEFT, false)
				if KMC.settings.saveFilter and saveFilterValue~= nil and saveFilterValue.order == tostring(i) then
					button:GetNamedChild("Label"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
					button.isColorInitiated = true
				end
			end
		end	
		panelControl:SetHidden(false)
	end
end
function KMC:resetFilterPanel()
	--d("--resetFilterPanel")
	for i=1,KMCUIRecipe:GetNumChildren() do
		local controlName = KMCUIRecipe:GetChild(i):GetName()
		if string.find(controlName, "KMC_RecipeFilter_") ~= nil then
			-- pour chaque filtre, on remet les items en non selectionné (color_icon)
			local listControl = GetControl(controlName.."List")
			for j=1,listControl:GetNumChildren() do
				if string.find(listControl:GetChild(j):GetName(), "Search") ~= nil then
					--editbox to empty
					GetControl(listControl:GetChild(j):GetName()).editbox:SetText("")
				elseif string.find(listControl:GetChild(j):GetName(), "BGDark") == nil then
					local buttonControl = GetControl(listControl:GetChild(j):GetName())
					buttonControl:GetChild(1):SetColor(HexToRGBA(buttonControl.color))
				end
			end
		end

	end
end
function KMC:isButtonItemSelected(control)
	local color = control.color or COLOR_ICON
	return not isControlColorEgalTo(control, color)	
end

function KMC_ToggleFilterItem(filterGroup,itemIndex)
--	d("KMC_ToggleFilterItem:"..filterGroup..","..itemIndex)
	local control = GetControl("KMC_RecipeFilter_"..tostring(filterGroup).."List"..itemIndex):GetChild(1)
	if KMC:isButtonItemSelected(control) then
		--deselect
		control:SetColor(HexToRGBA(control.color)) 
	else --select
		control:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		if tostring(filterGroup) == FILTER_SORT then --sort
			-- deselect other item
			local controlList = GetControl("KMC_RecipeFilter_"..tostring(filterGroup).."List")
			for i=1,controlList:GetNumChildren() do
				local itemControl = controlList:GetChild(i)
				if itemControl:GetName() ~= "KMC_RecipeFilter_"..tostring(filterGroup).."List"..itemIndex and string.find(itemControl:GetName(), "BGDark") == nil then
					itemControl:GetChild(1):SetColor(HexToRGBA(itemControl.color)) 
					itemControl.isColorInitiated = false
				end
			end
		end
	end
end

function KMC_ApplyFilter(button)
--	d("--KMC_ApplyFilter:"..tostring(button))
	if button ~= nil then
		KMC.selectedRecipe = nil
		KMCUICraftCount:SetHidden(true)
	end
	local order = 3
	local filters = {}
	local ingredients = {}
	KMC.writRecipes = nil
	for i=1,4 do
		filters[tostring(i)]=nil
	end
	-- in filters, find orange selected
	for i=1,KMCUIRecipe:GetNumChildren() do
		local panelName = KMCUIRecipe:GetChild(i):GetName()
		if string.find(panelName, "KMC_RecipeFilter_") ~= nil then
			local listControl = GetControl(panelName.."List")
			for j=1,listControl:GetNumChildren() do
				local controlName = listControl:GetChild(j):GetName()
				if string.find(controlName, "Search") ~= nil then
					-- editbox filter
					filters[FILTER_SEARCH] = {}
					filters[FILTER_SEARCH]["0"] = GetControl(controlName).editbox:GetText()
				elseif string.find(controlName, "BGDark") == nil then
--					d("->"..controlName)
					local buttonControl = GetControl(controlName)
					if KMC:isButtonItemSelected(GetControl(controlName..buttonControl.type)) then
						local listIndex = string.sub(panelName,18,string.len(panelName))
						local filterIndex = string.sub(controlName,string.len(panelName)+5,string.len(controlName))
--						d("->"..listIndex..",'"..filterIndex.."'")
						if listIndex == FILTER_SORT then --order
							order = filterIndex
						elseif listIndex == FILTER_EFFECT then
							--+1=Max Health, +2=Max Magicka, +4=Max Stamina, +8=Regen Health, +16=Regen Magicka, +32=Regen Stamina
							if filters[listIndex] == nil then filters[listIndex] = {} end
							if filters[listIndex]["0"] then
								filters[listIndex]["0"] = filters[listIndex]["0"]..filterIndex
--								filters[listIndex]["0"] = tonumber(filters[listIndex]["0"]) + tonumber(filterIndex) --tonumber(2^(filterIndex-1))
							else
								filters[listIndex]["0"] = tostring(filterIndex)
--								filters[listIndex]["0"] = tonumber(filterIndex)
							end
						else --filters
							if filters[listIndex] == nil then filters[listIndex] = {} end
							filters[listIndex][filterIndex] = true
						end
					end
				end
			end
		end
	end
	-- in ingredients, find orange selected
	local panelControl = GetControl("KMCUIItemList")
	for ingredientId,Ingredient in pairs(KMC.Ingredients) do
		local button = GetControl("KMC_Ingredient_"..tostring(ingredientId))
		if not button:GetNamedChild("Outline"):IsControlHidden() then
			local ingredientIndex = string.sub(button:GetName(),16,string.len(button:GetName()))
--d(button:GetName().."->"..ingredientIndex)
			ingredients[tonumber(ingredientIndex)] = true
		end
	end
	-- memorize filters option
	if KMC.settings.saveFilter then
		KMC.settings.saveFilterValue = {filters=filters, order=order, ingredients=ingredients}
	else
		KMC.settings.saveFilterValue = nil
	end
	KMC:ShowRecipes(filters,order,ingredients)
end
function KMC_ResetFilter(button)
	KMC:resetFilterPanel()
	KMC:resetIngredients()
end


-- // **********
-- //  UI Panel
-- // **********

function KMC:OpenUI()
	--other addons
	if KMC.activeAddon.WeaponChargeAlert then WeaponChargeAlert_Hide(true) end --hide
	if KMC.activeAddon.KhrillCraftingPostit then --add writ quest button
		addButton(KMCUIRecipe, "KMCUIRecipeKCPButton", KMC_GetKCPQuests, nil, nil, "|c"..COLOR_KHRILLSELECT..KMC.langString.MESSAGE_writQuest.."|r", TOP, TEXTURE_ICON["KCP"], nil, nil, nil, 48, 24, -10, 0, RIGHT, KMCUIRecipeLabel, LEFT, false)
	end
	if KMC.activeAddon.FireFilters then --reset Filters & hide it
		if FireFilter_SetFilter then FireFilter_SetFilter("All",false) end
		FireFiltersUI:SetHidden(true)
	end
	if KMC.activeAddon.ItemSaver or KMC.activeAddon.FCOItemSaver then -- built itemSaved list
		checkItemSaved()
	end
	
	--activate events
	if KMC.onStation then KMC:registerEvents(true) end
		
	--get recipes&ingredients
	KMC:ScanBag()
	KMC:ScanRecipes()
	--filter panels
	KMC:addFilterPanel()
	--reinit filters
	if not KMC.settings.saveFilter then KMC:resetFilterPanel() end
	
	if KMC.onStation then
		ZO_CheckButton_SetUnchecked(GetControl("ZO_ProvisionerTopLevelHaveIngredients"))
		ZO_CheckButton_SetUnchecked(GetControl("ZO_ProvisionerTopLevelHaveSkills"))
		KMC.savedVars.haveIngredientsChecked = false
		KMC.savedVars.haveSkillsChecked = false
		ZO_SharedProvisioner:DirtyRecipeList()
		
		-- change ESO popup position
		_G["ZO_ProvisionerTopLevelTooltip"]:SetAnchor(BOTTOM, ZO_ProvisionerTopLevel, BOTTOM, 0, -100)
		-- masking ESO UI
		_G["ZO_ProvisionerTopLevelTabs"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelMenuBarDivider"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelHaveIngredients"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelHaveSkills"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelNavigationContainer"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelNavigationDivider"]:SetAlpha(0.2)
		_G["ZO_ProvisionerTopLevelDetails"]:SetAlpha(0.5)
		_G["ZO_ProvisionerTopLevelDetailsDivider"]:SetAlpha(0.5)
		KEYBIND_STRIP:RemoveKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor)
	end
	
	--show UI
	KMC_SwitchItem(KMC.settings.ingredientEnable)
	KMC:addCharButton()
	KMC:CheckEnabledBtn()
--	KMCUICraftCount:SetHidden(not KMC.onStation) --multicraft slider only if on station
	PlaySound(SOUNDS.BOOK_OPEN)
	KMC:RefreshUI()
	
	-- check xp gain
	if KMC.settings.XPMode and KMC.onStation then EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_SKILL_XP_UPDATE, function(eventCode, skillType, skillIndex, reason, rank, previousXP, currentXP) if reason == PROGRESS_REASON_TRADESKILL then KMC:OnSkillXP(skillType, skillIndex, previousXP, currentXP) end end) end
end
function KMC:CloseUI()
	if not KMCUI:IsHidden() then
		KMC:msg("--CloseUI")
		if KMC.onStation then
			-- restore ESO UI
			_G["ZO_ProvisionerTopLevelTabs"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelMenuBarDivider"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelHaveIngredients"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelHaveSkills"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelNavigationContainer"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelNavigationDivider"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelDetails"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelDetailsDivider"]:SetAlpha(1)
			_G["ZO_ProvisionerTopLevelTooltip"]:SetHidden(false)
			KEYBIND_STRIP:AddKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor)
		end
		
		KMC.MsgWindow:SetHidden(true)
		KMC:ShowTooltip(false)
		KMCUI:SetHidden(true)
		PlaySound(SOUNDS.BOOK_CLOSE)
--		KMC:CleanUI()
		KMC:registerEvents(false)
		--other addons
		if KMC.activeAddon.WeaponChargeAlert then WeaponChargeAlert_Hide(false) end
		if KMC.activeAddon.FireFilters then FireFiltersUI:SetHidden(false) end
		if KMC.KCPHidden == true then KCPUI:SetHidden(true) end

		EVENT_MANAGER:UnregisterForEvent(KMC.name, EVENT_SKILL_XP_UPDATE)
	end
end
function KMC:CleanUI()
	--d("--CleanUI ")
	-- delete all recipes panel with Hidden in KMCUIRecipeList
	for i=1,KMCUIRecipeList:GetNumChildren() do
		local controlName = KMCUIRecipeList:GetChild(i):GetName()
		if string.find(controlName, "KMC_RecipePanel_") ~= nil then
			KMCUIRecipeList:GetChild(i):SetHidden(true)
		end
	end
end
function KMC:RefreshUI()
	KMC:msg("--RefreshUI")
	-- reset UI
	KMC:CleanUI()
	-- ingredients list
	KMC:ShowIngredients()
	--recipes list
	KMC:ShowRecipes()
	KMCUI:SetHidden(false)
end

function KMC:ShowTooltip(state)
	-- Tooltip when not at a fireplace
	local tooltip = KMC.Tooltip
	if state then
		-- Tooltip
--		d(KMC.selectedRecipe.Recipe.listIndex, KMC.selectedRecipe.Recipe.index, KMC.selectedRecipe.Recipe.itemLink)
		if KMC.selectedRecipe ~= nil then
			local link = KMC.selectedRecipe.Recipe.itemLink --GetRecipeResultItemLink(KMC.selectedRecipe.Recipe.listIndex, KMC.selectedRecipe.Recipe.index, LINK_STYLE_DEFAULT)
			if link ~= nil and link ~= "" then
				InitializeTooltip(tooltip)
				tooltip:SetLink(link)
			else
				PlaySound(SOUND_UNKNOW) --error
				KMC:AddMessage(zo_iconFormat(KMC.selectedRecipe.Recipe.icon, 16, 16).."|c"..GetItemQualityColor(KMC.selectedRecipe.Recipe.quality)..KMC.selectedRecipe.Recipe.name.."|r "..KMC.langString.MESSAGE_notKnown.." |c"..COLOR_KHRILLSELECT..KMC.activeChar.."|r")
				state = false
			end
		else
			state = false
		end
	end
	GetControl("KMCUICraftCount"):SetHidden(state)
	tooltip:SetHidden(not state)
end

function KMC:addCharButton()
--d("--addCharButton: "..KMC.selectedChar)
	-- add a button for each character who have crafting quests
	local cpt = 0
	local supportControl = GetControl("KMCUICharPanel")
	local nameControl = GetControl("KMCUICharName")
	local name, data
	for i=1, #KMC.characterList do
		name = KMC.characterList[i]
		data = KMC.GlobalRecipes[name]
		if name == KMC.selectedChar then
			nameControl:SetText(name)
			if name == KMC.activeChar then --active character in orange
				nameControl:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
				nameControl:SetStyleColor(HexToRGBA("000000FF"))
			else
				nameControl:SetColor(HexToRGBA(COLOR_ICON))
				nameControl:SetStyleColor(HexToRGBA(COLOR_KHRILLSELECT))
			end
		end
		if data.Recipes ~= nil then --and name ~= KMC.selectedChar then
			local button = addButton(supportControl, "KMCUICharPanelButton"..name, function(...) KMC_ToggleChar(KMC.characterList[i]) end, nil, nil, "|c"..COLOR_KHRILLSELECT..name.."|r", BOTTOM, TEXTURE_CLASS[data.classId], nil, nil, nil, 24, 24, 25*cpt, 0, LEFT, supportControl, LEFT, false)
			if name == KMC.selectedChar then --highlight orange
				button:GetChild(1):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
				button.isColorInitiated = true
				--GetControl("KMCUICharPanelButton"..name.."Texture"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
			else
				button:GetChild(1):SetColor(HexToRGBA(COLOR_ICON))
--				GetControl("KMCUICharPanelButton"..name.."Texture"):SetColor(HexToRGBA(COLOR_ICON))
			end
			button:SetHidden(not KMC.settings.charButton)
			cpt = cpt +1
		end
	end
end

function KMC:CheckEnabledBtn()
	-- button show/hide in ESO UI
	local oppositeTexture = 4
	if KMC.settings.BG == 4 then oppositeTexture = 2 end --rubbing book
    local button = addButton(ZO_ProvisionerTopLevelInfoBarDivider, "ZO_ProvisionerTopLevelButtonShowMasterCook", KMC_ToggleByKey, nil, nil, "|c"..COLOR_KHRILLSELECT..KMC.langString.SI_BINDING_NAME_KMCTOGGLE.."|r", TOP, KMC.BGTextures[KMC.settings.BG], KMC.BGTextures[oppositeTexture], KMC.BGTextures[oppositeTexture], nil, 48, 48, 50, -ZO_ProvisionerTopLevelInfoBarDivider:GetTop()+ZO_ProvisionerTopLevelMenuBarDivider:GetTop(), BOTTOMLEFT, ZO_ProvisionerTopLevelInfoBarDivider, TOPLEFT, not KMC.settings.enableButton)
end

function KMC:AddMessage(message,isSysMsg)
	if KMC.settings.msgWindow then
		KMC.MsgWindow:SetHidden(false)
		if isSysMsg then
			KMC.MsgWindow:AddText("|c"..COLOR_KHRILLSELECT..message.."|r")
		else
			KMC.MsgWindow:AddText(message)
		end
	else
		if isSysMsg then
			CHAT_SYSTEM:AddMessage("|c"..COLOR_KHRILLSELECT.."["..KMC.name.."]|r : "..message)
		else
			CHAT_SYSTEM:AddMessage(message)
		end
	end
end

function KMC:OnSliderMove(value)
--d("--OnSliderMove:"..value)
	KMC.sliderOffset = value
	KMC:UpdateRecipes()
end

function KMC:OnMouseWheel(delta)
--d("--OnMouseWheel:"..KMC.sliderOffset..","..delta)
	local offset = KMC.sliderOffset
	offset = offset - delta
	if (offset > KMC.maxRecipes-KMC.maxRow) then offset = KMC.maxRecipes-KMC.maxRow+1 end
	if (offset < 1) then offset = 1 end
	
	KMC.sliderOffset = offset
	KMCUIRecipeSlider:SetValue(offset)
	KMC:UpdateRecipes()
end


-- // **********
-- //  Events
-- // **********
function KMC:OnCraftingStationInteract(eventCode, craftSkill, sameStation)
	-- // active craft station
	if KMC.settings.Enable and craftSkill == CRAFTING_TYPE_PROVISIONING then 
		KMC:msg("--OnCrafting: "..craftSkill, false)
		KMC.onStation = true
		if IsInGamepadPreferredMode() then return end
		KMC:OpenUI()
	end
end
function KMC:OnEndCraftingStation(eventCode)
	KMC:msg("--OnEndCrafting", false)
	KMC.onStation = false
	KMC:CloseUI()
end
function KMC:OnCraftCompleted(eventCode, craftSkill)
--	d("--OnCraftCompleted"..craftSkill)
	if craftSkill == CRAFTING_TYPE_PROVISIONING then	
		-- check multicraft (slider)
		local control = GetControl("KMCUICraftCount")
		local count = control:GetValue()
		if count > 1 and KMC.selectedRecipe ~= nil then
			count = count -1
			control:SetValue(count)
			control.selText:SetText(count)
			local nbItem = tonumber(control.maxText:GetText()) -1
			control:SetMinMax(1, nbItem)
			control.maxText:SetText(nbItem)
			-- relaunch craft
			CraftProvisionerItem(KMC.selectedRecipe.Recipe.listIndex, KMC.selectedRecipe.Recipe.index)
		else
			-- rescan all
			KMC:ScanBag()
			KMC:ScanRecipes()
			-- not last used recipe => reset UI
			if KMC.writRecipes ~= nil then
				KMC:ShowRecipes(nil,nil,nil,KMC.writRecipes)
			else
				KMC_ApplyFilter(nil)
			end
		end
	end
end
function KMC:OnInventoryUpdate(eventCode, bagId, slotId, isNewItem, itemSoundCategory, updateReason)
--d("--OnInventoryUpdate:"..eventCode..","..bagId..","..slotId..","..tostring(isNewItem)..","..itemSoundCategory..","..updateReason)
--		GetLastCraftingResultItemInfo(integer resultIndex)
--		Returns: string name, textureName icon, integer stack, integer sellPrice, boolean meetsUsageRequirement, integer equipType, integer ItemType itemType, integer itemStyle, integer quality, integer ItemUISoundCategory soundCategory, integer itemInstanceId 
	if KMC.onStation then
		local name, icon, stack, sellPrice, meetsUsageRequirement, equipType, itemType, itemStyle, quality, soundCategory, itemInstanceId = GetLastCraftingResultItemInfo(1)
		local itemInstanceId = SignItemId(GetItemInstanceId(bagId, slotId))
		if KMC.writRecipes ~= nil and isNewItem then -- item crafted for writ
			if KMC.activeAddon.KhrillCraftingPostit and KMC.activeAddon.ItemSaver and KMC.settings.ItemSaverLock then
				-- lock by itemSaver
				if not ItemSaver_IsItemSaved(bagId, slotId) then
					ItemSaver_ToggleItemSave(bagId, slotId)
					KMC:AddMessage(zo_iconFormat(icon, 16, 16).."|c"..GetItemQualityColor(quality)..zo_strformat(SI_TOOLTIP_ITEM_NAME, name).."|r "..KMC.langString.MESSAGE_locked.." |c"..COLOR_KHRILLSELECT.."ItemSaver|r")
				end
				KMC.accountSettings.ItemSaved[GetItemLinkID(GetItemLink(bagId, slotId))] = name
				KMC.accountSettings.ItemSaved[itemInstanceId] = name
			end
			if KMC.activeAddon.FCOItemSaver and KMC.settings.FCOItemSaverLock then
				-- lock by FCOItemSaver
				if not FCOIsMarked(itemInstanceId, -1) then
					if FCOMarkItem(bagId, slotId, 1, true,  false) then			
						KMC:AddMessage(zo_iconFormat(icon, 16, 16).."|c"..GetItemQualityColor(quality)..zo_strformat(SI_TOOLTIP_ITEM_NAME, name).."|r "..KMC.langString.MESSAGE_locked.." |c"..COLOR_KHRILLSELECT.."FCOItemSaver|r")
					end
				end		
				KMC.accountSettings.ItemSaved[GetItemLinkID(GetItemLink(bagId, slotId))] = name
				KMC.accountSettings.ItemSaved[itemInstanceId] = name
			end
		end
		if KMC.accountSettings.ItemSaved[itemInstanceId] ~= nil then KMC.accountSettings.ItemSaved[itemInstanceId] = name end
	end
end

function KMC:OnCraftCountChange(delta)
	-- slider for multi craft
	if delta ~= nil then
		local count = KMCUICraftCount:GetValue() + delta
		if count > 0 and count <= tonumber(KMCUICraftCount.maxText:GetText()) then
			KMCUICraftCount:SetValue(count)
			KMCUICraftCount.selText:SetText(count)
		end
	end
end

function KMC:OnSkillXP(skillType, skillIndex, previousXP, currentXP)
	-- // when gain xp via crafting
	local name,rank = GetSkillLineInfo(skillType, skillIndex)
	local gainXP = currentXP - previousXP
	
	KMC:AddMessage(KMC.langString.MESSAGE_skill .. " |c".. COLOR_KHRILLSELECT .. zo_strformat(SI_TOOLTIP_ITEM_NAME, name) .. "|r = |c" ..COLOR_KHRILLSELECT.. "+" .. gainXP .. "xp|r")
end

function KMC_SaveAnchor()
	-- Save the new position of windows
--d("--SaveAnchor")
	local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = KMCUI:GetAnchor()
	if isValidAnchor then
		KMC.settings.anchor = { point, relativePoint, offsetX, offsetY }
	end
end

function KMC_ToggleByKey()
	-- show/hide by keybind
	if KMCUI:IsHidden() then
		SetGameCameraUIMode(true)
		KMC:OpenUI()
	else
		KMC:CloseUI()
--		if KMC.onStation then KEYBIND_STRIP:AddKeybindButtonGroup(PROVISIONER.mainKeybindStripDescriptor) end	--only with toggle to reactive ESO UI button
		SetGameCameraUIMode(false)
	end
end
function KMC_ToggleChar(name)
	-- button for change selectedChar and so Recipes
--	d("--KMC_ToggleChar: "..name)
	KMC:AddMessage(KMC.langString.MESSAGE_charSelect.." |c"..COLOR_KHRILLSELECT..name.."|r")
	KMC.selectedChar = name
	KMC.RecipeList = {}
--	TableCopy(KMC.GlobalRecipes[KMC.selectedChar].Recipes, KMC.RecipeList)
	KMC.RecipeList = KMC.GlobalRecipes[KMC.selectedChar].Recipes
	KMC:RefreshUI()
	KMC:addCharButton()
end

function KMC_SwitchItem(state)
	if state == nil then state = KMCUIItem:IsControlHidden() end
	local isVisible = state -- and KMCUIItem:IsControlHidden()
	if isVisible then --show
		KMCUIIconLTexture:SetColor(HexToRGBA(COLOR_NOCOLOR))
		KMCUIItem:SetHidden(false)
		KMCUIRecipe:SetDrawLayer(DL_BACKGROUND)
	else --hide
		KMC:resetIngredients()
		KMCUIIconLTexture:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		KMCUIItem:SetHidden(true)
	end
end
function KMC_CloseBtn()
	KMC:CloseUI()
end

function KMC_GetKCPQuests()
	-- if KhrillCraftingPostit active, get writ quests recipe
	if KMC.KCPHidden == nil then KMC.KCPHidden = KCPUI:IsHidden() end
	-- first show provisioner quests on KCP
	KCP_SetPanel(CRAFTING_TYPE_PROVISIONING)
	if KCPUI.WandalizeRefresh then KCPUI.WandalizeRefresh() end
	local Quests = KCP_GetQuests()
	if Quests ~= nil and Quests[CraftTable[CRAFTING_TYPE_PROVISIONING]] ~= nil then
	-- get condition quests info
		local concatWritRecipes = ""
		for conditionIndex, condition in pairs(Quests[CraftTable[CRAFTING_TYPE_PROVISIONING]].conditions) do 
			concatWritRecipes = concatWritRecipes .. condition.name.."_"
		end
		KMC.writRecipes = concatWritRecipes
		KMC:ShowRecipes(nil,nil,nil,concatWritRecipes)
	else
		PlaySound(SOUND_UNKNOW) --error
		KMC:AddMessage(KMC.langString.TEXT_writQuest.." "..KMC.langString.MESSAGE_notKnown.." |c"..COLOR_KHRILLSELECT..KCP_getSelectedChar().."|r", true)		
	end
end


-- // **********
-- //  Init
-- // **********
function KMC:GetLanguage()
	local lang = GetCVar("language.2")
--	lang = "en" --for testing
	
	--supported languages
	if(lang == "fr") then return lang end
	if(lang == "de") then return lang end
	if(lang == "es") then return lang end

	--return english if not supported
	return "en"
end
function KMC:initGlobalRecipes()
	-- init KMC.RecipeList structure
	KMC.RecipeList = {}
	for recipeListIndex=1,GetNumRecipeLists() do
		--GetRecipeListInfo(recipeListIndex)
		--Returns: string name, integer numRecipes, textureName upIcon, textureName downIcon, textureName overIcon, textureName disabledIcon, string createSound 
		local recipeListName, numRecipes, upIcon, downIcon, overIcon, disabledIcon, createSound = GetRecipeListInfo(recipeListIndex)
		KMC.RecipeList[recipeListIndex] = {name=recipeListName, icon=downIcon, count=numRecipes, known=0, recipes={}}
	end
	-- init KMC.RecipesESOTree for ESO recipes UI
	KMC.RecipesESOTree[PROVISIONER_SPECIAL_INGREDIENT_TYPE_SPICES] = nil
	KMC.RecipesESOTree[PROVISIONER_SPECIAL_INGREDIENT_TYPE_FLAVORING] = nil
	-- init KMC.GlobalRecipes structure with data from account's characters
	local characterList = {}
	for account, accountData in pairs(KhrillMasterCook_settings.Default) do
		if account == ZO_DisplayNameDisplayName:GetText() then
			for player, data in pairs (accountData) do
				if data.Recipes ~= nil then table.insert(characterList, player) end
			end
			table.sort(characterList)
			KMC.characterList = characterList
			
			for i=1, #characterList do
				player = characterList[i]
				if accountData[player] then
					data = accountData[player]
					KMC.GlobalRecipes[player] = {}
					if data.classId ~= nil then KMC.GlobalRecipes[player].classId = data.classId end
					if data.Recipes ~= nil then KMC.GlobalRecipes[player].Recipes = data.Recipes end
				end
			end
		end
	end
end
function KMC:CreateMsgWnd()
	-- Message Window (LibMsgWin)
	local LIBMW = LibStub:GetLibrary("LibMsgWin-1.0")
	if KMC.MsgWindow == nil then
		KMC.MsgWindow = LIBMW:CreateMsgWindow(KMC.name.."Msg", "|c"..COLOR_TITLE..KMC.titleName.."|r - |c"..COLOR_KHRILLSELECT.."Messages|r", 20000, 2000)
	end
	KMC.MsgWindow:SetHidden(true)
	KMC.MsgWindow:SetDimensions(300, 300)
	KMC.MsgWindow:ClearAnchors()
	KMC.MsgWindow:SetAnchor(TOPLEFT, ZO_ChatWindowBg, TOPRIGHT, -10, 4)
	KMC.MsgWindow:ChangeTextFade(20000, 2000)	
end

function KMC:OnInit(eventCode, addOnName)
	-- check addons compatibility is active?
	if ( addOnName == "AdvancedFilters") then KMC.activeAddon.AdvancedFilters = true end
	if ( addOnName == "WeaponChargeAlert") then KMC.activeAddon.WeaponChargeAlert = true end
	if ( addOnName == "KhrillCraftingPostit") then KMC.activeAddon.KhrillCraftingPostit = true end
	if ( addOnName == "ItemSaver") then KMC.activeAddon.ItemSaver = true end
	if ( addOnName == "FCOItemSaver") then KMC.activeAddon.FCOItemSaver = true end
	if ( addOnName == "FireFilters") then KMC.activeAddon.FireFilters = true end

    if ( addOnName ~= KMC.name) then return end
	
	--language
	KMC.langString = KMC_Lang[KMC:GetLanguage()]
	--bindings
	ZO_CreateStringId("SI_BINDING_NAME_KMCTOGGLE", KMC.langString.SI_BINDING_NAME_KMCTOGGLE)
	--settings
	KMC.activeChar = zo_strformat(SI_UNIT_NAME, GetRawUnitName("player"))
	KMC.selectedChar = KMC.activeChar
	KMC.settings = ZO_SavedVars:New(KMC.name .. "_settings", 1, nil, KMC.defaults)
	KMC.accountSettings = ZO_SavedVars:NewAccountWide(KMC.name .. "_settings", 1, nil, KMC.accountDefaults)
	--KMC.settings = KMC.defaults --reinit for test
	KMC.settings.classId = GetUnitClassId("player")
	local defaults = { haveIngredientsChecked = true, haveSkillsChecked = true, }
	KMC.savedVars = ZO_SavedVars:New("ZO_Ingame_SavedVariables", 1, "Provisioner", defaults)
	KMC.savedVars.haveIngredientsChecked = false
	KMC.savedVars.haveSkillsChecked = false
	KMC:initGlobalRecipes()
	KMC:CommandOptionPanel()

	-- UI init
	KMCUITitle:SetText(KMC.titleName)
	KMCUIIconLTexture:SetTexture(TEXTURE_ICON["Left"])
	KMCUIIconRTexture:SetTexture(TEXTURE_ICON["Right"])
	KMCUICloseButtonTexture:SetTexture(TEXTURE_ICON["Close"])
	KMCUIRecipeLabel:SetText(KMC.langString.TEXT_recipes)
	KMCUIItemLabel:SetText(KMC.langString.TEXT_ingredients)
	KMCUIItemCloseButtonTexture:SetTexture(TEXTURE_ICON["Close"])
	KMCUIApplyButton:SetText("|c"..COLOR_KHRILLSELECT..KMC.langString.TEXT_apply.."|r")
	KMCUIResetButton:SetText("|c"..COLOR_TITLE..KMC.langString.TEXT_reset.."|r")
	KMC:ChangeBG()
	-- multicraft slider
	addSlider(KMCUI, "KMCUICraftCount", nil, 1, 100, 1, 1, ORIENTATION_HORIZONTAL, -15, 10, TOP, KMCUIRecipeList, BOTTOM)
	-- recipes scroll slider
	local slider = CreateControl("KMCUIRecipeSlider",KMCUIRecipe,CT_SLIDER)
	slider:SetDimensions(30,KMC.maxRow*31)
	slider:SetMouseEnabled(true)
	slider:SetThumbTexture(TEXTURE_ICON["Slider"],TEXTURE_ICON["Slider"],TEXTURE_ICON["Slider"],20,50,0,0,1,1)
	slider:SetValueStep(1)
	slider:SetAnchor(TOPRIGHT,KMCUIRecipe,TOPRIGHT,22,10)
	if slider:GetHandler("OnValueChanged") == nil then slider:SetHandler("OnValueChanged",function(self,value,eventReason) KMC:OnSliderMove(value) end) end

	-- position
	KMCUI:AllowBringToTop(false)
	KMCUI:ClearAnchors()
	KMCUI:SetAnchor(KMC.settings.anchor[1], KMCUI:GetParent(), KMC.settings.anchor[2], KMC.settings.anchor[3], KMC.settings.anchor[4])

	-- Message window
	KMC:CreateMsgWnd()
	-- ToolTip
	local tooltip = WINDOW_MANAGER:CreateControlFromVirtual("KMCUITooltip", KMCUI, "ZO_ItemIconTooltip")
    tooltip:ClearAnchors()
    tooltip:SetAnchor(TOP, KMCUIRecipeList, BOTTOM, 0, 50)
    tooltip:SetHidden(true)
    tooltip:SetClampedToScreen(true)
	KMC.Tooltip = tooltip
	
	-- Register starting events
	EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_CRAFTING_STATION_INTERACT, function(...) KMC:OnCraftingStationInteract(...) end)
--	EVENT_MANAGER:UnregisterForEvent(KMC.name, EVENT_ADD_ON_LOADED)
end
function KMC:registerEvents(state)
	if state then
		EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_END_CRAFTING_STATION_INTERACT, function(...) KMC:OnEndCraftingStation(...) end)
		EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_CRAFT_COMPLETED, function(...) KMC:OnCraftCompleted(...) end)
		EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function(...) KMC:OnInventoryUpdate(...) end)
	else
		EVENT_MANAGER:UnregisterForEvent(KMC.name, EVENT_END_CRAFTING_STATION_INTERACT)
		EVENT_MANAGER:UnregisterForEvent(KMC.name, EVENT_CRAFT_COMPLETED)
		EVENT_MANAGER:UnregisterForEvent(KMC.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
	end
end

EVENT_MANAGER:RegisterForEvent(KMC.name, EVENT_ADD_ON_LOADED , function(_event, _name) KMC:OnInit(_event, _name) end)

-- // **********
-- //  Settings
-- // **********
function KMC:ToggleEnable(value)
	KMC.settings.Enable = value
	KMC:registerEvents(KMC.settings.Enable)	
end
function KMC:TogglePositionning(value)
	KMC.positionning = value
	-- enable/disabled
	KMCUI:SetHidden(not KMC.positionning)
end
function KMC:ToggleEnableBtn(value)
	KMC.settings.enableButton = value
	KMC:CheckEnabledBtn()
end

function KMC:ChangeBG()
	-- change BG texture or color mode
	GetControl("KMCUIRecipeBGColor"):SetAlpha(KMC.settings.alpha)
--	GetControl("KMCUIRecipeBGTexture"):SetAlpha(KMC.settings.alpha)
	GetControl("KMCUIItemBGColor"):SetAlpha(KMC.settings.alpha)
--	GetControl("KMCUIItemBGTexture"):SetAlpha(KMC.settings.alpha)

	GetControl("KMCUIRecipeBGTexture"):SetHidden(KMC.settings.BG == 1)	
	GetControl("KMCUIRecipeBGColor"):SetHidden(KMC.settings.BG ~= 1)	
	GetControl("KMCUIItemBGTexture"):SetHidden(KMC.settings.BG == 1)	
	GetControl("KMCUIItemBGColor"):SetHidden(KMC.settings.BG ~= 1)	
	
	if KMC.settings.BG == 1 then
		-- No texture, colored BG
		GetControl("KMCUIRecipeBGColor"):SetCenterColor(HexToRGBA(KMC.settings.BGColor))
		GetControl("KMCUIItemBGColor"):SetCenterColor(HexToRGBA(KMC.settings.BGColor))
	else
		GetControl("KMCUIItemBGTexture"):SetColor(HexToRGBA(KMC.settings.BGColor))
		GetControl("KMCUIRecipeBGTexture"):SetTexture(KMC.BGTextures[KMC.settings.BG])	
		GetControl("KMCUIRecipeBGTexture"):SetTextureCoords(KMC.BGTexturesCoord[KMC.settings.BG][1],KMC.BGTexturesCoord[KMC.settings.BG][2],KMC.BGTexturesCoord[KMC.settings.BG][3],KMC.BGTexturesCoord[KMC.settings.BG][4])
	end
end

function KMC:CommandOptionPanel()
	--// Settings panel LAM2
	local LAM2 = LibStub("LibAddonMenu-2.0")
	if ( not LAM2 ) then return end
	
	local ADDON_NAME = KMC.titleName
	local ADDON_VERSION="v"..KMC.version
	local panelData = {
			type = "panel",
			name = ADDON_NAME,
			displayName = "|c"..COLOR_KHRILLSELECT.. ADDON_NAME .."|r (" .. KMC.langString.LOCALE .. ")",
			author = "|c"..COLOR_KHRILLSELECT.."Khrill|r",
			version = ADDON_VERSION,
			slashCommand = "/KMC",
			registerForRefresh = true,
			registerForDefaults = true,
	}
	local settingsPanel = LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	local optionsTable = {
		------------SETTINGS--------------
		{	-- enable
			type = "checkbox",
			name = KMC.langString.Settings_enable,
			tooltip = KMC.langString.Settings_enable,
			getFunc = function() return KMC.settings.Enable end,
			setFunc = function(value) KMC:ToggleEnable(value) end,
			width = "full",
			default = KMC.defaults.Enable,
		},
		{
			type = "description",
			text = KMC.langString.Settings_keybindText,
			width = "full",
		},
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KMC.langString.Settings_control.."|r",
			width = "full",
		},
		{	-- characters buttons
			type = "checkbox",
			name = KMC.langString.Settings_charBtn,
			tooltip = KMC.langString.Settings_charBtn,
			getFunc = function() return KMC.settings.charButton end,
			setFunc = function(value)
				KMC.settings.charButton = value
				KMCUICharPanel:SetHidden(not KMC.settings.charButton)
			end,
			width = "full",
			default = KMC.defaults.charButton,
		},
		{	-- stats by level
			type = "checkbox",
			name = KMC.langString.Settings_statLvl,
			tooltip = KMC.langString.Settings_statLvlTip,
			getFunc = function() return KMC.settings.statLvl end,
			setFunc = function(value) KMC.settings.statLvl = value end,
			width = "full",
			default = KMC.defaults.statLvl,
		},
		{	-- Show XP
			type = "checkbox",
			name = KMC.langString.Settings_showXp,
			tooltip = KMC.langString.Settings_showXpTip,
			getFunc = function() return KMC.settings.XPMode end,
			setFunc = function(value) KMC.settings.XPMode = value end,
			width = "full",	
			default = KMC.defaults.XPMode,
		},
		{	-- Msg window
			type = "checkbox",
			name = KMC.langString.Settings_msgWnd,
			tooltip = KMC.langString.Settings_msgWndTip,
			getFunc = function() return KMC.settings.msgWindow end,
			setFunc = function(value) KMC.settings.msgWindow=value end,
			width = "full",
			default = KMC.defaults.msgWindow,
		},
		{	-- sysmessage
			type = "checkbox",
			name = KMC.langString.Settings_sysmessage,
			tooltip = KMC.langString.Settings_sysmessage,
			getFunc = function() return KMC.settings.sysmessage end,
			setFunc = function(value) KMC.settings.sysmessage = value end,
			width = "full",
			default = KMC.defaults.sysmessage,
		},
		
		------------INTERFACE--------------
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KMC.langString.Settings_interface.."|r",
			width = "full",
		},
		{	-- BG texture (with preview)
			type = "dropdown",
			name = KMC.langString.Settings_BG,
			tooltip = KMC.langString.Settings_choose,
			choices = KMC.BGTexturesLabel,
			getFunc = function() return KMC.BGTexturesLabel[KMC.settings.BG] end,
			setFunc = function(value)
						KMC.settings.BG = getKeyByValue(KMC.BGTexturesLabel, value)
						if KMC.BGTextures[KMC.settings.BG] ~= nil then GetControl("KMC_BGPreview"):SetTexture(KMC.BGTextures[KMC.settings.BG]) end
--						GetControl("KMC_BGPreview"):SetHidden(KMC.settings.BG == 1)
						KMC:ChangeBG()
			end,
			width = "full",
			default = KMC.BGTexturesLabel[KMC.defaults.BG],
			reference = "KMC_BGPreview_Dropdown"
		},
		{	-- BG color
			type = "colorpicker",
			name = KMC.langString.Settings_BGColor,
			tooltip = KMC.langString.Settings_choose,
			getFunc = function()
						local r, g, b, a = HexToRGBA(KMC.settings.BGColor)
						return r, g, b
			end,
			setFunc = function(r, g, b)
						KMC.settings.BGColor = RGBAToHex(r, g, b, 1)
						GetControl("KMCUIRecipeBGColor"):SetCenterColor(r,g,b,1)
						GetControl("KMCUIItemBGColor"):SetCenterColor(r,g,b,1)
						GetControl("KMCUIItemBGTexture"):SetColor(r,g,b,1)
			end,
--			disabled = function() return (KMC.settings.BG ~= 1) end,
--			default = function() return HexToRGBA(KMC.defaults.FontColor) end --function() KMC.settings.BGColor = KMC.defaults.BGColor end,
		},
		{	-- ESO UI fade
			type = "checkbox",
			name = KMC.langString.Settings_ESOUiFade,
			tooltip = KMC.langString.Settings_ESOUiFadeTip,
			getFunc = function() return KMC.settings.EsoUiFade end,
			setFunc = function(value) KMC.settings.EsoUiFade = value end,
			width = "full",	
			default = KMC.defaults.EsoUiFade,
		},
		{	-- save Filter
			type = "checkbox",
			name = KMC.langString.Settings_saveFilter,
			tooltip = KMC.langString.Settings_saveFilter,
			getFunc = function() return KMC.settings.saveFilter end,
			setFunc = function(value) KMC.settings.saveFilter = value end,
			width = "full",	
			default = KMC.defaults.saveFilter,
		},
		{	-- ingredient visible
			type = "checkbox",
			name = KMC.langString.Settings_ingredientsEnable,
			tooltip = KMC.langString.Settings_ingredientsEnableTip,
			getFunc = function() return KMC.settings.ingredientEnable end,
			setFunc = function(value) KMC.settings.ingredientEnable = value end,
			width = "full",	
			default = KMC.defaults.ingredientEnable,
		},
		{	-- ingredient sort by quantity
			type = "checkbox",
			name = KMC.langString.Settings_ingredientsQuantity,
			tooltip = KMC.langString.Settings_ingredientsQuantityTip,
			getFunc = function() return KMC.settings.ingredientQuantity end,
			setFunc = function(value) KMC.settings.ingredientQuantity = value end,
			width = "full",	
			default = KMC.defaults.ingredientQuantity,
		},
		{	-- result's item level
			type = "checkbox",
			name = KMC.langString.Settings_itemLevel,
			tooltip = KMC.langString.Settings_itemLevelTip,
			getFunc = function() return KMC.settings.itemLevel end,
			setFunc = function(value) KMC.settings.itemLevel = value end,
			width = "full",	
			default = KMC.defaults.itemLevel,
		},

		------------POSITIONNING--------------
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KMC.langString.Settings_positionning.."|r",
			width = "full",
		},
		{
			type = "description",
			text = KMC.langString.Settings_positionningText,
			width = "full",
		},
		{
			type = "checkbox",
			name = KMC.langString.Settings_enable,
			tooltip = KMC.langString.Settings_enable,
			getFunc = function() return false end,
			setFunc = function(value) KMC:TogglePositionning(value) end,
			width = "full",
			default = false,
		},
		------------ADDONS COMPATIBILITY--------------
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KMC.langString.Settings_AddonCompatibility.."|r",
			width = "full",
		},
		{	-- ItemSaver filtering
			type = "checkbox",
			name = KMC.langString.Settings_itemSaver,
			tooltip = KMC.langString.Settings_itemSaverTip,
			warning = KMC.langString.TEXT_addonsNeeded .."\n   ItemSaver",
			getFunc = function() return KMC.settings.ItemSaver end,
			setFunc = function(value) KMC.settings.ItemSaver = value end,
			width = "full",
			disabled = function() return not KMC.activeAddon.ItemSaver end,
			default = KMC.defaults.ItemSaver,
		},
		{	-- ItemSaver lock
			type = "checkbox",
			name = KMC.langString.Settings_itemSaverLock,
			tooltip = KMC.langString.Settings_itemSaverLockTip,
			warning = KMC.langString.TEXT_addonsNeeded .."\n   ItemSaver\n   |c"..COLOR_KHRILLSELECT.."Khrill|r Crafting Post-it",
			getFunc = function() return KMC.settings.ItemSaverLock end,
			setFunc = function(value) KMC.settings.ItemSaverLock = value end,
			width = "full",
			disabled = function() return not KMC.activeAddon.ItemSaver or not KMC.activeAddon.KhrillCraftingPostit end,
			default = KMC.defaults.ItemSaverLock,
		},
		{	-- FCOItemSaver
			type = "checkbox",
			name = KMC.langString.Settings_FCOIS,
			tooltip = KMC.langString.Settings_FCOISTip,
			warning = KMC.langString.TEXT_addonsNeeded .."\n   |c00FF00FCO |cFFFF00Item Saver|r",
			getFunc = function() return KMC.settings.FCOItemSaver end,
			setFunc = function(value) KMC.settings.FCOItemSaver = value end,
			width = "full",
			disabled = function() return not KMC.activeAddon.FCOItemSaver end,
			default = KMC.defaults.FCOItemSaver,
		},
		{	-- FCOItemSaver lock
			type = "checkbox",
			name = KMC.langString.Settings_FCOISLock,
			tooltip = KMC.langString.Settings_FCOISLockTip,
			warning = KMC.langString.TEXT_addonsNeeded .."\n   |c00FF00FCO |cFFFF00Item Saver|r\n   |c"..COLOR_KHRILLSELECT.."Khrill|r Crafting Post-it",
			getFunc = function() return KMC.settings.FCOItemSaverLock end,
			setFunc = function(value) KMC.settings.FCOItemSaverLock = value end,
			width = "full",
			disabled = function() return not KMC.activeAddon.FCOItemSaver or not KMC.activeAddon.KhrillCraftingPostit end,
			default = KMC.defaults.FCOItemSaverLock,
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)

	--For preview anim picture
	local preview, previewIcon
    previewIcon = function(panel)
        if panel == settingsPanel then
			local controlPos = 10 --count control position for BG texture
            preview = WINDOW_MANAGER:CreateControl("KMC_BGPreview", panel.controlsToRefresh[controlPos], CT_TEXTURE)
			preview:SetParent(KMC_BGPreview_Dropdown)
			preview:SetHidden(false)
			preview:SetDimensions(48, 48)
            preview:SetAnchor(RIGHT, panel.controlsToRefresh[controlPos].dropdown:GetControl(), LEFT, -10, 0)
			preview:SetMouseEnabled(true)
			if KMC.BGTextures[KMC.settings.BG] ~= nil then preview:SetTexture(KMC.BGTextures[KMC.settings.BG]) end

            CALLBACK_MANAGER:UnregisterCallback("LAM-PanelControlsCreated", previewIcon)
        end
    end
    CALLBACK_MANAGER:RegisterCallback("LAM-PanelControlsCreated", previewIcon)
end

SLASH_COMMANDS["/mastercook"] = function()
	KMC_ToggleByKey()
end

SLASH_COMMANDS["/kmcstat"] = function()
d("--STATS by Level--")
	local byLevel={}
	for recipeListIndex=1, #KMC.RecipeList do
		local numRecipes = KMC.RecipeList[recipeListIndex].count
		local color = COLOR_QUALITY[2]
		if KMC.RecipeQuality[recipeListIndex] ~= nil then color = GetItemQualityColor(KMC.RecipeQuality[recipeListIndex]) end
		d("Liste "..recipeListIndex..":"..zo_iconFormat(KMC.RecipeList[recipeListIndex].icon, 16, 16).." |c"..color..KMC.RecipeList[recipeListIndex].name.. "|r : "..KMC.RecipeList[recipeListIndex].known.."/"..numRecipes)
		byLevel={}
		for recipeIndex=1,numRecipes do
			--GetRecipeInfo(luaindex recipeListIndex, luaindex recipeIndex)
			--Returns: bool known, string name, integer numIngredients, integer provisionerLevelReq, integer qualityReq, ProvisionerSpecialIngredientType specialIngredientType
--d(GetRecipeInfo(recipeListIndex, recipeIndex))
			local known, name, numIngredients, provisionerLevelReq, qualityReq, specialIngredientType = GetRecipeInfo(recipeListIndex, recipeIndex)
			if not byLevel[provisionerLevelReq] then
				byLevel[provisionerLevelReq] = {}
				byLevel[provisionerLevelReq].count = 0
				byLevel[provisionerLevelReq].known = 0
			end
			byLevel[provisionerLevelReq].count = byLevel[provisionerLevelReq].count +1
			if known then byLevel[provisionerLevelReq].known = byLevel[provisionerLevelReq].known +1 end
		end
		for k,v in pairs(byLevel) do
			if k ==0 then
				d("-> Inconnu: "..v.count)
			else
				d("->Level "..k..": "..v.count)
			end
		end
	end
end


-- // **********
-- //  Debug
-- // **********
function KMC:msg(texte, extend)
	if KMC.isDebug then
		d(texte)
		if extend == true then

			d("-------")
		end
	end
end

SLASH_COMMANDS["/KMCdebug"] = function()
	KMC.isDebug = not KMC.isDebug
	KMC:msg("-- KMC Debug -- "..tostring(KMC.isDebug))
end
